/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.generic.GenericData.Array;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Path
/*     */ {
/*  21 */   protected static final AsupLogger LOG = AsupLogger.getLogger(Path.class);
/*     */   private final Identifier id;
/*     */   private static final String COMMA_SEPERATOR = ",";
/*     */   
/*     */   public Path(Identifier id)
/*     */   {
/*  27 */     this.id = id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*  32 */   private Map<String, LinkedList<String>> pathHashVsPaths = new HashMap();
/*     */   
/*     */   public Map<String, LinkedList<String>> getPaths() {
/*  35 */     return this.pathHashVsPaths;
/*     */   }
/*     */   
/*     */   public void addPath(String pathHash, LinkedList<String> path) {
/*  39 */     this.pathHashVsPaths.put(pathHash, path);
/*     */   }
/*     */   
/*     */   private List<String> getAllDistinctPaths()
/*     */   {
/*  44 */     List<String> paths = new ArrayList();
/*  45 */     StringBuilder pathBuilder = null;
/*  46 */     Iterator<String> pathIt = null;
/*  47 */     for (LinkedList<String> path : this.pathHashVsPaths.values()) {
/*  48 */       pathBuilder = new StringBuilder();
/*  49 */       pathIt = path.iterator();
/*  50 */       while (pathIt.hasNext()) {
/*  51 */         pathBuilder.append((String)pathIt.next());
/*  52 */         if (pathIt.hasNext())
/*  53 */           pathBuilder.append(",");
/*     */       }
/*  55 */       paths.add(pathBuilder.toString());
/*     */     }
/*     */     
/*     */ 
/*  59 */     List<String> orderedDistinctPath = new ArrayList(paths);
/*  60 */     Collections.sort(orderedDistinctPath);
/*  61 */     return orderedDistinctPath;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private Set<Utf8> getAllTheDistinctObjects()
/*     */   {
/*  68 */     List<String> paths = getAllDistinctPaths();
/*  69 */     Set<Utf8> uniqueObjects = new HashSet();
/*  70 */     String[] pathArr = null;
/*     */     
/*  72 */     for (String path : paths) {
/*  73 */       pathArr = path.split(",");
/*  74 */       for (String p : pathArr) {
/*  75 */         uniqueObjects.add(new Utf8(p.toUpperCase()));
/*     */       }
/*     */     }
/*  78 */     return uniqueObjects;
/*     */   }
/*     */   
/*     */   public List<String> getAllPaths() {
/*  82 */     return getAllDistinctPaths();
/*     */   }
/*     */   
/*     */   public Set<Utf8> getAllUniqueObjects()
/*     */   {
/*  87 */     return getAllTheDistinctObjects();
/*     */   }
/*     */   
/*     */   public Identifier setPathToIdentifier() {
/*  91 */     List<String> p = getAllPaths();
/*  92 */     List<Utf8> paths = new ArrayList();
/*  93 */     String p1 = null;
/*     */     
/*  95 */     Iterator<String> it = p.iterator();
/*  96 */     while (it.hasNext()) {
/*  97 */       p1 = (String)it.next();
/*  98 */       paths.add(new Utf8(p1.toUpperCase()));
/*     */     }
/*     */     
/* 101 */     GenericData.Array<Utf8> avroPaths = new GenericData.Array(paths.size(), ARMASchema.PATH.getSchema());
/*     */     
/* 103 */     avroPaths.addAll(paths);
/*     */     
/* 105 */     this.id.setPath(avroPaths);
/* 106 */     this.id.setIdentifierProcessed(String.valueOf(Boolean.FALSE));
/* 107 */     return this.id;
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getInputPath() {
/* 111 */     List<String> paths = getAllPaths();
/*     */     
/* 113 */     if (LOG.isDebugEnabled()) {
/* 114 */       LOG.debug(null, "Complete Path traversed:" + paths.toString());
/*     */     }
/* 116 */     List<Utf8> utfPaths = new ArrayList();
/* 117 */     String path = null;
/* 118 */     Iterator<String> it = paths.iterator();
/* 119 */     while (it.hasNext()) {
/* 120 */       path = (String)it.next();
/*     */       
/* 122 */       utfPaths.add(new Utf8(path.toUpperCase()));
/*     */     }
/*     */     
/* 125 */     GenericData.Array<Utf8> avroPaths = new GenericData.Array(paths.size(), ARMASchema.PATH.getSchema());
/*     */     
/* 127 */     avroPaths.addAll(utfPaths);
/* 128 */     return avroPaths;
/*     */   }
/*     */   
/*     */   public void clear() {
/* 132 */     this.pathHashVsPaths.clear();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\Path.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */