/*     */ package com.netapp.asupdata.client.ARMA;
/*     */ 
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
/*     */ import com.netapp.asup.metamodel.MergeType;
/*     */ import com.netapp.asup.metamodel.NodeObject;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.NoSuchElementException;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ARMAObjectInstanceIteratorImpl
/*     */   implements ARMAObjectInstanceIterator
/*     */ {
/*     */   private ARMAObjectImpl metaObject;
/*     */   private Iterator<Utf8> systemIterator;
/*     */   private Iterator<Utf8> instanceKeyIterator;
/*  25 */   private Utf8 currSystemId = null;
/*     */   
/*     */   private Map<Utf8, Map<Utf8, GenericRecord>> systemToGenericRecord;
/*     */   
/*  29 */   private int totalNoOfInstances = 0;
/*     */   
/*  31 */   private int remainingInstanceCount = 0;
/*     */   
/*     */   private Map<Utf8, List<Utf8>> keyIndex;
/*     */   
/*     */   public ARMAObjectInstanceIteratorImpl(ARMAObjectImpl object, Map<Utf8, Map<Utf8, GenericRecord>> systemToGenericRecord, Map<Utf8, List<Utf8>> keyIndex)
/*     */   {
/*  37 */     this.metaObject = object;
/*  38 */     this.keyIndex = keyIndex;
/*  39 */     this.systemToGenericRecord = systemToGenericRecord;
/*     */     
/*  41 */     switch (getMergeType())
/*     */     {
/*     */     case DIRECT: 
/*     */     case LATEST: 
/*  45 */       if (!keyIndex.isEmpty()) {
/*  46 */         this.totalNoOfInstances = keyIndex.size();
/*  47 */         this.instanceKeyIterator = keyIndex.keySet().iterator(); }
/*  48 */       break;
/*     */     
/*     */ 
/*     */     case INDIRECT: 
/*  52 */       for (Utf8 key : systemToGenericRecord.keySet()) {
/*  53 */         Map<Utf8, GenericRecord> instanceMap = (Map)systemToGenericRecord.get(key);
/*  54 */         if (null != instanceMap) {
/*  55 */           this.totalNoOfInstances += instanceMap.size();
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */     
/*  61 */     this.remainingInstanceCount = this.totalNoOfInstances;
/*     */   }
/*     */   
/*     */   private MergeType getMergeType() {
/*  65 */     return this.metaObject.getNodeObject().getMergeType();
/*     */   }
/*     */   
/*     */   public int size() {
/*  69 */     return this.totalNoOfInstances;
/*     */   }
/*     */   
/*     */   public String getObjectName() {
/*  73 */     return this.metaObject.getObjectName();
/*     */   }
/*     */   
/*     */   public boolean hasNext() {
/*  77 */     if (this.remainingInstanceCount > 0) {
/*  78 */       return true;
/*     */     }
/*  80 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */   public ARMAObjectInstance next()
/*     */   {
/*  86 */     if (hasNext()) {
/*  87 */       Utf8 instanceKey = null;
/*  88 */       switch (getMergeType())
/*     */       {
/*     */       case DIRECT: 
/*     */       case LATEST: 
/*  92 */         if (!this.keyIndex.isEmpty()) {
/*  93 */           instanceKey = (Utf8)this.instanceKeyIterator.next();
/*  94 */           List<Utf8> systemIds = (List)this.keyIndex.get(instanceKey);
/*     */           
/*  96 */           this.currSystemId = ((Utf8)systemIds.get(0)); }
/*  97 */         break;
/*     */       }
/*     */       
/*     */       
/* 101 */       if (null == this.systemIterator)
/*     */       {
/* 103 */         this.systemIterator = this.systemToGenericRecord.keySet().iterator();
/* 104 */         if (this.systemIterator.hasNext()) {
/* 105 */           this.currSystemId = ((Utf8)this.systemIterator.next());
/* 106 */           this.instanceKeyIterator = ((Map)this.systemToGenericRecord.get(this.currSystemId)).keySet().iterator();
/*     */           
/* 108 */           if (this.instanceKeyIterator.hasNext()) {
/* 109 */             instanceKey = (Utf8)this.instanceKeyIterator.next();
/*     */           } else {
/* 111 */             return next();
/*     */           }
/*     */         }
/* 114 */       } else if (this.instanceKeyIterator.hasNext()) {
/* 115 */         instanceKey = (Utf8)this.instanceKeyIterator.next();
/* 116 */       } else if (this.systemIterator.hasNext()) {
/* 117 */         this.currSystemId = ((Utf8)this.systemIterator.next());
/* 118 */         this.instanceKeyIterator = ((Map)this.systemToGenericRecord.get(this.currSystemId)).keySet().iterator();
/*     */         
/* 120 */         if (this.instanceKeyIterator.hasNext()) {
/* 121 */           instanceKey = (Utf8)this.instanceKeyIterator.next();
/*     */         } else {
/* 123 */           return next();
/*     */         }
/*     */       }
/*     */       
/* 127 */       this.remainingInstanceCount -= 1;
/* 128 */       GenericRecord genericRecord = (GenericRecord)((Map)this.systemToGenericRecord.get(this.currSystemId)).get(instanceKey);
/*     */       
/* 130 */       return new ARMAObjectInstanceImpl(this.metaObject, this.currSystemId, instanceKey, genericRecord);
/*     */     }
/*     */     
/* 133 */     throw new NoSuchElementException("Next Element does not exist");
/*     */   }
/*     */   
/*     */   public void remove() {
/* 137 */     throw new UnsupportedOperationException("Remove operation is not supported");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asupdata\client\ARMA\ARMAObjectInstanceIteratorImpl.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */