/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.JAXBException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class IllegalAnnotationException
/*     */   extends JAXBException
/*     */ {
/*     */   private final List<List<Location>> pos;
/*     */   private static final long serialVersionUID = 1L;
/*     */   
/*     */   public IllegalAnnotationException(String message, Locatable src)
/*     */   {
/*  29 */     super(message);
/*  30 */     this.pos = build(new Locatable[] { src });
/*     */   }
/*     */   
/*     */   public IllegalAnnotationException(String message, Annotation src) {
/*  34 */     this(message, cast(src));
/*     */   }
/*     */   
/*     */   public IllegalAnnotationException(String message, Locatable src1, Locatable src2) {
/*  38 */     super(message);
/*  39 */     this.pos = build(new Locatable[] { src1, src2 });
/*     */   }
/*     */   
/*     */   public IllegalAnnotationException(String message, Annotation src1, Annotation src2) {
/*  43 */     this(message, cast(src1), cast(src2));
/*     */   }
/*     */   
/*     */   public IllegalAnnotationException(String message, Annotation src1, Locatable src2) {
/*  47 */     this(message, cast(src1), src2);
/*     */   }
/*     */   
/*     */   public IllegalAnnotationException(String message, Throwable cause, Locatable src) {
/*  51 */     super(message, cause);
/*  52 */     this.pos = build(new Locatable[] { src });
/*     */   }
/*     */   
/*     */   private static Locatable cast(Annotation a) {
/*  56 */     if ((a instanceof Locatable)) {
/*  57 */       return (Locatable)a;
/*     */     }
/*  59 */     return null;
/*     */   }
/*     */   
/*     */   private List<List<Location>> build(Locatable... srcs) {
/*  63 */     List<List<Location>> r = new ArrayList();
/*  64 */     for (Locatable l : srcs) {
/*  65 */       if (l != null) {
/*  66 */         List<Location> ll = convert(l);
/*  67 */         if ((ll != null) && (!ll.isEmpty()))
/*  68 */           r.add(ll);
/*     */       }
/*     */     }
/*  71 */     return Collections.unmodifiableList(r);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private List<Location> convert(Locatable src)
/*     */   {
/*  78 */     if (src == null) { return null;
/*     */     }
/*  80 */     List<Location> r = new ArrayList();
/*  81 */     for (; src != null; src = src.getUpstream())
/*  82 */       r.add(src.getLocation());
/*  83 */     return Collections.unmodifiableList(r);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public List<List<Location>> getSourcePos()
/*     */   {
/* 139 */     return this.pos;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 152 */     StringBuilder sb = new StringBuilder(getMessage());
/*     */     
/* 154 */     for (List<Location> locs : this.pos) {
/* 155 */       sb.append("\n\tthis problem is related to the following location:");
/* 156 */       for (Location loc : locs) {
/* 157 */         sb.append("\n\t\tat ").append(loc.toString());
/*     */       }
/*     */     }
/* 160 */     return sb.toString();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\IllegalAnnotationException.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */