/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeAttributePropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementPropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeValuePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.util.Collection;
/*     */ import java.util.Iterator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class PropertyFactory
/*     */ {
/*     */   private static final Constructor<? extends Property>[] propImpls;
/*     */   
/*     */   static
/*     */   {
/*  32 */     Class<? extends Property>[] implClasses = { SingleElementLeafProperty.class, null, null, ArrayElementLeafProperty.class, null, null, SingleElementNodeProperty.class, SingleReferenceNodeProperty.class, SingleMapNodeProperty.class, ArrayElementNodeProperty.class, ArrayReferenceNodeProperty.class, null };
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  50 */     propImpls = new Constructor[implClasses.length];
/*  51 */     for (int i = 0; i < propImpls.length; i++) {
/*  52 */       if (implClasses[i] != null)
/*     */       {
/*  54 */         propImpls[i] = implClasses[i].getConstructors()[0];
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Property create(JAXBContextImpl grammar, RuntimePropertyInfo info)
/*     */   {
/*  64 */     PropertyKind kind = info.kind();
/*     */     
/*  66 */     switch (kind) {
/*     */     case ATTRIBUTE: 
/*  68 */       return new AttributeProperty(grammar, (RuntimeAttributePropertyInfo)info);
/*     */     case VALUE: 
/*  70 */       return new ValueProperty(grammar, (RuntimeValuePropertyInfo)info);
/*     */     case ELEMENT: 
/*  72 */       if (((RuntimeElementPropertyInfo)info).isValueList()) {
/*  73 */         return new ListElementProperty(grammar, (RuntimeElementPropertyInfo)info);
/*     */       }
/*     */       break;
/*     */     case REFERENCE: case MAP: 
/*     */       break;
/*     */     default: 
/*  79 */       if (!$assertionsDisabled) { throw new AssertionError();
/*     */       }
/*     */       break;
/*     */     }
/*  83 */     boolean isCollection = info.isCollection();
/*  84 */     boolean isLeaf = isLeaf(info);
/*     */     
/*  86 */     Constructor<? extends Property> c = propImpls[(6 + 0 + kind.propertyIndex)];
/*     */     try {
/*  88 */       return (Property)c.newInstance(new Object[] { grammar, info });
/*     */     } catch (InstantiationException e) {
/*  90 */       throw new InstantiationError(e.getMessage());
/*     */     } catch (IllegalAccessException e) {
/*  92 */       throw new IllegalAccessError(e.getMessage());
/*     */     } catch (InvocationTargetException e) {
/*  94 */       Throwable t = e.getCause();
/*  95 */       if ((t instanceof Error))
/*  96 */         throw ((Error)t);
/*  97 */       if ((t instanceof RuntimeException)) {
/*  98 */         throw ((RuntimeException)t);
/*     */       }
/* 100 */       throw new AssertionError(t);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   static boolean isLeaf(RuntimePropertyInfo info)
/*     */   {
/* 109 */     Collection<? extends RuntimeTypeInfo> types = info.ref();
/* 110 */     if (types.size() != 1) { return false;
/*     */     }
/* 112 */     RuntimeTypeInfo rti = (RuntimeTypeInfo)types.iterator().next();
/* 113 */     if (!(rti instanceof RuntimeNonElement)) { return false;
/*     */     }
/* 115 */     if (info.id() == ID.IDREF)
/*     */     {
/* 117 */       return true;
/*     */     }
/* 119 */     if (((RuntimeNonElement)rti).getTransducer() == null)
/*     */     {
/*     */ 
/*     */ 
/* 123 */       return false;
/*     */     }
/* 125 */     if (!info.getIndividualType().equals(rti.getType())) {
/* 126 */       return false;
/*     */     }
/* 128 */     return true;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\PropertyFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */