/*     */ package com.sun.xml.bind.v2.runtime.reflect;
/*     */ 
/*     */ import com.sun.istack.SAXException2;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.ClassFactory;
/*     */ import com.sun.xml.bind.v2.TODO;
/*     */ import com.sun.xml.bind.v2.model.core.Adapter;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Patcher;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.lang.ref.WeakReference;
/*     */ import java.lang.reflect.Array;
/*     */ import java.lang.reflect.ParameterizedType;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.WeakHashMap;
/*     */ import java.util.concurrent.Callable;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Lister<BeanT, PropT, ItemT, PackT>
/*     */ {
/*     */   private static final Map<Class, WeakReference<Lister>> arrayListerCache;
/*     */   static final Map<Class, Lister> primitiveArrayListers;
/*     */   
/*     */   public abstract ListIterator<ItemT> iterator(PropT paramPropT, XMLSerializer paramXMLSerializer);
/*     */   
/*     */   public abstract PackT startPacking(BeanT paramBeanT, Accessor<BeanT, PropT> paramAccessor)
/*     */     throws AccessorException;
/*     */   
/*     */   public abstract void addToPack(PackT paramPackT, ItemT paramItemT)
/*     */     throws AccessorException;
/*     */   
/*     */   public abstract void endPacking(PackT paramPackT, BeanT paramBeanT, Accessor<BeanT, PropT> paramAccessor)
/*     */     throws AccessorException;
/*     */   
/*     */   public abstract void reset(BeanT paramBeanT, Accessor<BeanT, PropT> paramAccessor)
/*     */     throws AccessorException;
/*     */   
/*     */   public static <BeanT, PropT, ItemT, PackT> Lister<BeanT, PropT, ItemT, PackT> create(Type fieldType, ID idness, Adapter<Type, Class> adapter)
/*     */   {
/*  89 */     Class rawType = Navigator.REFLECTION.erasure(fieldType);
/*     */     
/*     */     Lister l;
/*     */     
/*  93 */     if (rawType.isArray()) {
/*  94 */       Class itemType = rawType.getComponentType();
/*  95 */       l = getArrayLister(itemType);
/*     */     } else { Lister l;
/*  97 */       if (Collection.class.isAssignableFrom(rawType)) {
/*  98 */         Type bt = Navigator.REFLECTION.getBaseClass(fieldType, Collection.class);
/*  99 */         Class itemType; Class itemType; if ((bt instanceof ParameterizedType)) {
/* 100 */           itemType = Navigator.REFLECTION.erasure(((ParameterizedType)bt).getActualTypeArguments()[0]);
/*     */         } else
/* 102 */           itemType = Object.class;
/* 103 */         l = new CollectionLister(getImplClass(rawType));
/*     */       } else {
/* 105 */         return null; } }
/*     */     Lister l;
/* 107 */     Class itemType; if (idness == ID.IDREF) {
/* 108 */       l = new IDREFS(l, itemType);
/*     */     }
/* 110 */     if (adapter != null) {
/* 111 */       l = new AdaptedLister(l, (Class)adapter.adapterType);
/*     */     }
/* 113 */     return l;
/*     */   }
/*     */   
/*     */   private static Class getImplClass(Class fieldType) {
/* 117 */     return ClassFactory.inferImplClass(fieldType, ClassFactory.COLLECTION_IMPL_CLASSES);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static Lister getArrayLister(Class componentType)
/*     */   {
/* 130 */     Lister l = null;
/* 131 */     if (componentType.isPrimitive()) {
/* 132 */       l = (Lister)primitiveArrayListers.get(componentType);
/*     */     } else {
/* 134 */       WeakReference<Lister> wr = (WeakReference)arrayListerCache.get(componentType);
/* 135 */       if (wr != null)
/* 136 */         l = (Lister)wr.get();
/* 137 */       if (l == null) {
/* 138 */         l = new ArrayLister(componentType);
/* 139 */         arrayListerCache.put(componentType, new WeakReference(l));
/*     */       }
/*     */     }
/* 142 */     assert (l != null);
/* 143 */     return l;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static final class ArrayLister<BeanT, ItemT>
/*     */     extends Lister<BeanT, ItemT[], ItemT, Lister.Pack<ItemT>>
/*     */   {
/*     */     private final Class<ItemT> itemType;
/*     */     
/*     */ 
/*     */ 
/*     */     public ArrayLister(Class<ItemT> itemType)
/*     */     {
/* 158 */       this.itemType = itemType;
/*     */     }
/*     */     
/*     */     public ListIterator<ItemT> iterator(final ItemT[] objects, XMLSerializer context) {
/* 162 */       new ListIterator() {
/* 163 */         int idx = 0;
/*     */         
/* 165 */         public boolean hasNext() { return this.idx < objects.length; }
/*     */         
/*     */         public ItemT next()
/*     */         {
/* 169 */           return (ItemT)objects[(this.idx++)];
/*     */         }
/*     */       };
/*     */     }
/*     */     
/*     */     public Lister.Pack startPacking(BeanT current, Accessor<BeanT, ItemT[]> acc) {
/* 175 */       return new Lister.Pack(this.itemType);
/*     */     }
/*     */     
/*     */     public void addToPack(Lister.Pack<ItemT> objects, ItemT o) {
/* 179 */       objects.add(o);
/*     */     }
/*     */     
/*     */     public void endPacking(Lister.Pack<ItemT> pack, BeanT bean, Accessor<BeanT, ItemT[]> acc) throws AccessorException {
/* 183 */       acc.set(bean, pack.build());
/*     */     }
/*     */     
/*     */     public void reset(BeanT o, Accessor<BeanT, ItemT[]> acc) throws AccessorException {
/* 187 */       acc.set(o, (Object[])Array.newInstance(this.itemType, 0));
/*     */     }
/*     */   }
/*     */   
/*     */   public static final class Pack<ItemT> extends ArrayList<ItemT>
/*     */   {
/*     */     private final Class<ItemT> itemType;
/*     */     
/*     */     public Pack(Class<ItemT> itemType) {
/* 196 */       this.itemType = itemType;
/*     */     }
/*     */     
/*     */     public ItemT[] build() {
/* 200 */       return super.toArray((Object[])Array.newInstance(this.itemType, size()));
/*     */     }
/*     */   }
/*     */   
/*     */   static
/*     */   {
/* 123 */     arrayListerCache = Collections.synchronizedMap(new WeakHashMap());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 207 */     primitiveArrayListers = new HashMap();
/*     */     
/*     */ 
/*     */ 
/* 211 */     PrimitiveArrayListerBoolean.register();
/* 212 */     PrimitiveArrayListerByte.register();
/* 213 */     PrimitiveArrayListerCharacter.register();
/* 214 */     PrimitiveArrayListerDouble.register();
/* 215 */     PrimitiveArrayListerFloat.register();
/* 216 */     PrimitiveArrayListerInteger.register();
/* 217 */     PrimitiveArrayListerLong.register();
/* 218 */     PrimitiveArrayListerShort.register();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final class CollectionLister<BeanT, T extends Collection>
/*     */     extends Lister<BeanT, T, Object, T>
/*     */   {
/*     */     private final Class<? extends T> implClass;
/*     */     
/*     */ 
/*     */ 
/*     */     public CollectionLister(Class<? extends T> implClass)
/*     */     {
/* 233 */       this.implClass = implClass;
/*     */     }
/*     */     
/*     */     public ListIterator iterator(T collection, XMLSerializer context) {
/* 237 */       final Iterator itr = collection.iterator();
/* 238 */       new ListIterator() {
/*     */         public boolean hasNext() {
/* 240 */           return itr.hasNext();
/*     */         }
/*     */         
/* 243 */         public Object next() { return itr.next(); }
/*     */       };
/*     */     }
/*     */     
/*     */     public T startPacking(BeanT bean, Accessor<BeanT, T> acc) throws AccessorException
/*     */     {
/* 249 */       T collection = (Collection)acc.get(bean);
/* 250 */       if (collection == null) {
/* 251 */         collection = (Collection)ClassFactory.create(this.implClass);
/*     */       }
/* 253 */       collection.clear();
/* 254 */       return collection;
/*     */     }
/*     */     
/*     */     public void addToPack(T collection, Object o) {
/* 258 */       collection.add(o);
/*     */     }
/*     */     
/*     */ 
/*     */     public void endPacking(T collection, BeanT bean, Accessor<BeanT, T> acc)
/*     */       throws AccessorException
/*     */     {
/* 265 */       acc.set(bean, collection);
/*     */     }
/*     */     
/*     */     public void reset(BeanT bean, Accessor<BeanT, T> acc) throws AccessorException {
/* 269 */       ((Collection)acc.get(bean)).clear();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private static final class IDREFS<BeanT, PropT>
/*     */     extends Lister<BeanT, PropT, String, IDREFS<BeanT, PropT>.Pack>
/*     */   {
/*     */     private final Lister<BeanT, PropT, Object, Object> core;
/*     */     
/*     */     private final Class itemType;
/*     */     
/*     */ 
/*     */     public IDREFS(Lister core, Class itemType)
/*     */     {
/* 284 */       this.core = core;
/* 285 */       this.itemType = itemType;
/*     */     }
/*     */     
/*     */     public ListIterator<String> iterator(PropT prop, XMLSerializer context) {
/* 289 */       ListIterator i = this.core.iterator(prop, context);
/*     */       
/* 291 */       return new Lister.IDREFSIterator(i, context, null);
/*     */     }
/*     */     
/*     */     public IDREFS<BeanT, PropT>.Pack startPacking(BeanT bean, Accessor<BeanT, PropT> acc) {
/* 295 */       return new Pack(bean, acc);
/*     */     }
/*     */     
/*     */     public void addToPack(IDREFS<BeanT, PropT>.Pack pack, String item) {
/* 299 */       pack.add(item);
/*     */     }
/*     */     
/*     */     public void endPacking(IDREFS<BeanT, PropT>.Pack pack, BeanT bean, Accessor<BeanT, PropT> acc) {}
/*     */     
/*     */     public void reset(BeanT bean, Accessor<BeanT, PropT> acc) throws AccessorException
/*     */     {
/* 306 */       this.core.reset(bean, acc);
/*     */     }
/*     */     
/*     */ 
/*     */     private class Pack
/*     */       implements Patcher
/*     */     {
/*     */       private final BeanT bean;
/* 314 */       private final List<String> idrefs = new ArrayList();
/*     */       private final UnmarshallingContext context;
/*     */       private final Accessor<BeanT, PropT> acc;
/*     */       
/*     */       public Pack(Accessor<BeanT, PropT> bean) {
/* 319 */         this.bean = bean;
/* 320 */         this.acc = acc;
/* 321 */         this.context = UnmarshallingContext.getInstance();
/* 322 */         this.context.addPatcher(this);
/*     */       }
/*     */       
/*     */       public void add(String item) {
/* 326 */         this.idrefs.add(item);
/*     */       }
/*     */       
/*     */       public void run()
/*     */         throws SAXException
/*     */       {
/*     */         try
/*     */         {
/* 334 */           Object pack = Lister.this.startPacking(this.bean, this.acc);
/*     */           
/* 336 */           for (String id : this.idrefs) {
/* 337 */             Callable callable = this.context.getObjectFromId(id, Lister.IDREFS.this.itemType);
/*     */             Object t;
/*     */             try
/*     */             {
/* 341 */               t = callable != null ? callable.call() : null;
/*     */             } catch (SAXException e) {
/* 343 */               throw e;
/*     */             } catch (Exception e) {
/* 345 */               throw new SAXException2(e);
/*     */             }
/*     */             
/* 348 */             if (t == null) {
/* 349 */               this.context.errorUnresolvedIDREF(this.bean, id);
/*     */             } else {
/* 351 */               TODO.prototype();
/* 352 */               Lister.this.addToPack(pack, t);
/*     */             }
/*     */           }
/*     */           
/* 356 */           Lister.this.endPacking(pack, this.bean, this.acc);
/*     */         } catch (AccessorException e) {
/* 358 */           this.context.handleError(e);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public static final class IDREFSIterator
/*     */     implements ListIterator<String>
/*     */   {
/*     */     private final ListIterator i;
/*     */     
/*     */     private final XMLSerializer context;
/*     */     
/*     */     private Object last;
/*     */     
/*     */ 
/*     */     private IDREFSIterator(ListIterator i, XMLSerializer context)
/*     */     {
/* 377 */       this.i = i;
/* 378 */       this.context = context;
/*     */     }
/*     */     
/*     */     public boolean hasNext() {
/* 382 */       return this.i.hasNext();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public Object last()
/*     */     {
/* 389 */       return this.last;
/*     */     }
/*     */     
/*     */     public String next() throws SAXException, JAXBException {
/* 393 */       this.last = this.i.next();
/* 394 */       String id = this.context.grammar.getBeanInfo(this.last, true).getId(this.last, this.context);
/* 395 */       if (id == null) {
/* 396 */         this.context.errorMissingId(this.last);
/*     */       }
/* 398 */       return id;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 405 */   public static final Lister ERROR = new Lister() {
/*     */     public ListIterator iterator(Object o, XMLSerializer context) {
/* 407 */       return Lister.EMPTY_ITERATOR;
/*     */     }
/*     */     
/*     */     public Object startPacking(Object o, Accessor accessor) {
/* 411 */       return null;
/*     */     }
/*     */     
/*     */ 
/*     */     public void addToPack(Object o, Object o1) {}
/*     */     
/*     */ 
/*     */     public void endPacking(Object o, Object o1, Accessor accessor) {}
/*     */     
/*     */ 
/*     */     public void reset(Object o, Accessor accessor) {}
/*     */   };
/*     */   
/* 424 */   private static final ListIterator EMPTY_ITERATOR = new ListIterator() {
/*     */     public boolean hasNext() {
/* 426 */       return false;
/*     */     }
/*     */     
/*     */     public Object next() {
/* 430 */       throw new IllegalStateException();
/*     */     }
/*     */   };
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\Lister.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */