/*      */ package com.sun.xml.bind.v2.schemagen;
/*      */ 
/*      */ import com.sun.istack.Nullable;
/*      */ import com.sun.xml.bind.api.CompositeStructure;
/*      */ import com.sun.xml.bind.v2.TODO;
/*      */ import com.sun.xml.bind.v2.model.core.Adapter;
/*      */ import com.sun.xml.bind.v2.model.core.ArrayInfo;
/*      */ import com.sun.xml.bind.v2.model.core.AttributePropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*      */ import com.sun.xml.bind.v2.model.core.Element;
/*      */ import com.sun.xml.bind.v2.model.core.ElementInfo;
/*      */ import com.sun.xml.bind.v2.model.core.ElementPropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.EnumConstant;
/*      */ import com.sun.xml.bind.v2.model.core.EnumLeafInfo;
/*      */ import com.sun.xml.bind.v2.model.core.MapPropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.NonElement;
/*      */ import com.sun.xml.bind.v2.model.core.NonElementRef;
/*      */ import com.sun.xml.bind.v2.model.core.PropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.ReferencePropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*      */ import com.sun.xml.bind.v2.model.core.TypeInfoSet;
/*      */ import com.sun.xml.bind.v2.model.core.TypeRef;
/*      */ import com.sun.xml.bind.v2.model.core.ValuePropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.WildcardMode;
/*      */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*      */ import com.sun.xml.bind.v2.runtime.SwaRefAdapter;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.Any;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.AttrDecls;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.ComplexContent;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.ComplexExtension;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.ComplexType;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.ComplexTypeHost;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.ExplicitGroup;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.Import;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.LocalAttribute;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.LocalElement;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.NoFixedFacet;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.Occurs;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.Schema;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.SimpleContent;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.SimpleExtension;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.SimpleRestrictionModel;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.SimpleType;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.SimpleTypeHost;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.TopLevelAttribute;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.TopLevelElement;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.TypeHost;
/*      */ import com.sun.xml.bind.v2.schemagen.xmlschema.Wildcard;
/*      */ import com.sun.xml.txw2.TXW;
/*      */ import com.sun.xml.txw2.TxwException;
/*      */ import com.sun.xml.txw2.TypedXmlWriter;
/*      */ import com.sun.xml.txw2.output.ResultFactory;
/*      */ import java.io.IOException;
/*      */ import java.io.OutputStream;
/*      */ import java.io.Writer;
/*      */ import java.net.URI;
/*      */ import java.net.URISyntaxException;
/*      */ import java.util.Comparator;
/*      */ import java.util.HashMap;
/*      */ import java.util.LinkedHashSet;
/*      */ import java.util.Map;
/*      */ import java.util.Map.Entry;
/*      */ import java.util.Set;
/*      */ import java.util.TreeMap;
/*      */ import java.util.logging.Level;
/*      */ import java.util.logging.Logger;
/*      */ import javax.activation.MimeType;
/*      */ import javax.xml.bind.SchemaOutputResolver;
/*      */ import javax.xml.namespace.QName;
/*      */ import javax.xml.transform.Result;
/*      */ import javax.xml.transform.stream.StreamResult;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public final class XmlSchemaGenerator<T, C, F, M>
/*      */ {
/*   92 */   private static final Logger logger = com.sun.xml.bind.Util.getClassLogger();
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  103 */   private final Map<String, XmlSchemaGenerator<T, C, F, M>.Namespace> namespaces = new TreeMap(NAMESPACE_COMPARATOR);
/*      */   
/*      */ 
/*      */   private Navigator<T, C, F, M> navigator;
/*      */   
/*      */ 
/*      */   private final TypeInfoSet<T, C, F, M> types;
/*      */   
/*      */ 
/*      */   private final NonElement<T, C> stringType;
/*      */   
/*      */ 
/*      */   private final NonElement<T, C> anyType;
/*      */   
/*      */ 
/*      */ 
/*      */   public XmlSchemaGenerator(Navigator<T, C, F, M> navigator, TypeInfoSet<T, C, F, M> types)
/*      */   {
/*  121 */     this.navigator = navigator;
/*  122 */     this.types = types;
/*      */     
/*  124 */     this.stringType = types.getTypeInfo(navigator.ref(String.class));
/*  125 */     this.anyType = types.getAnyTypeInfo();
/*      */     
/*      */ 
/*  128 */     for (ClassInfo<T, C> ci : types.beans().values())
/*  129 */       add(ci);
/*  130 */     for (ElementInfo<T, C> ei1 : types.getElementMappings(null).values())
/*  131 */       add(ei1);
/*  132 */     for (EnumLeafInfo<T, C> ei : types.enums().values())
/*  133 */       add(ei);
/*  134 */     for (ArrayInfo<T, C> a : types.arrays().values())
/*  135 */       add(a);
/*      */   }
/*      */   
/*      */   private XmlSchemaGenerator<T, C, F, M>.Namespace getNamespace(String uri) {
/*  139 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = (Namespace)this.namespaces.get(uri);
/*  140 */     if (n == null)
/*  141 */       this.namespaces.put(uri, n = new Namespace(uri));
/*  142 */     return n;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void add(ClassInfo<T, C> clazz)
/*      */   {
/*  154 */     assert (clazz != null);
/*      */     
/*  156 */     String nsUri = null;
/*      */     
/*  158 */     if (clazz.getClazz() == this.navigator.asDecl(CompositeStructure.class)) {
/*  159 */       return;
/*      */     }
/*  161 */     if (clazz.isElement())
/*      */     {
/*  163 */       nsUri = clazz.getElementName().getNamespaceURI();
/*  164 */       XmlSchemaGenerator<T, C, F, M>.Namespace ns = getNamespace(nsUri);
/*  165 */       ns.classes.add(clazz);
/*  166 */       ns.addDependencyTo(clazz.getTypeName());
/*      */       
/*      */ 
/*  169 */       add(clazz.getElementName(), false, clazz);
/*      */     }
/*      */     
/*  172 */     QName tn = clazz.getTypeName();
/*  173 */     if (tn != null) {
/*  174 */       nsUri = tn.getNamespaceURI();
/*      */ 
/*      */     }
/*  177 */     else if (nsUri == null) {
/*  178 */       return;
/*      */     }
/*      */     
/*  181 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = getNamespace(nsUri);
/*  182 */     n.classes.add(clazz);
/*      */     
/*      */ 
/*  185 */     for (PropertyInfo<T, C> p : clazz.getProperties()) {
/*  186 */       n.processForeignNamespaces(p);
/*  187 */       if ((p instanceof AttributePropertyInfo)) {
/*  188 */         AttributePropertyInfo<T, C> ap = (AttributePropertyInfo)p;
/*  189 */         String aUri = ap.getXmlName().getNamespaceURI();
/*  190 */         if (aUri.length() > 0)
/*      */         {
/*  192 */           getNamespace(aUri).addGlobalAttribute(ap);
/*  193 */           n.addDependencyTo(ap.getXmlName());
/*      */         }
/*      */       }
/*  196 */       if ((p instanceof ElementPropertyInfo)) {
/*  197 */         ElementPropertyInfo<T, C> ep = (ElementPropertyInfo)p;
/*  198 */         for (TypeRef<T, C> tref : ep.getTypes()) {
/*  199 */           String eUri = tref.getTagName().getNamespaceURI();
/*  200 */           if ((eUri.length() > 0) && (!eUri.equals(n.uri))) {
/*  201 */             getNamespace(eUri).addGlobalElement(tref);
/*  202 */             n.addDependencyTo(tref.getTagName());
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*  209 */     ClassInfo<T, C> bc = clazz.getBaseClass();
/*  210 */     if (bc != null) {
/*  211 */       add(bc);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   public void add(ElementInfo<T, C> elem)
/*      */   {
/*  218 */     assert (elem != null);
/*      */     
/*  220 */     QName name = elem.getElementName();
/*  221 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = getNamespace(name.getNamespaceURI()); XmlSchemaGenerator<T, C, F, M>.Namespace 
/*  222 */       tmp47_46 = n;tmp47_46.getClass();n.elementDecls.put(name.getLocalPart(), new XmlSchemaGenerator.Namespace.ElementWithType(tmp47_46, true, elem.getContentType()));
/*      */     
/*      */ 
/*  225 */     n.processForeignNamespaces(elem.getProperty());
/*      */   }
/*      */   
/*      */   public void add(EnumLeafInfo<T, C> envm) {
/*  229 */     assert (envm != null);
/*      */     
/*  231 */     String nsUri = null;
/*      */     
/*  233 */     if (envm.isElement())
/*      */     {
/*  235 */       nsUri = envm.getElementName().getNamespaceURI();
/*  236 */       XmlSchemaGenerator<T, C, F, M>.Namespace ns = getNamespace(nsUri);
/*  237 */       ns.enums.add(envm);
/*  238 */       ns.addDependencyTo(envm.getTypeName());
/*      */       
/*      */ 
/*  241 */       add(envm.getElementName(), false, envm);
/*      */     }
/*      */     
/*  244 */     QName typeName = envm.getTypeName();
/*  245 */     if (typeName != null) {
/*  246 */       nsUri = typeName.getNamespaceURI();
/*      */     }
/*  248 */     else if (nsUri == null) {
/*  249 */       return;
/*      */     }
/*      */     
/*  252 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = getNamespace(nsUri);
/*  253 */     n.enums.add(envm);
/*      */     
/*      */ 
/*  256 */     n.addDependencyTo(envm.getBaseType().getTypeName());
/*      */   }
/*      */   
/*      */   public void add(ArrayInfo<T, C> a) {
/*  260 */     assert (a != null);
/*      */     
/*  262 */     String namespaceURI = a.getTypeName().getNamespaceURI();
/*  263 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = getNamespace(namespaceURI);
/*  264 */     n.arrays.add(a);
/*      */     
/*      */ 
/*  267 */     n.addDependencyTo(a.getItemType().getTypeName());
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void add(QName tagName, boolean isNillable, NonElement<T, C> type)
/*      */   {
/*  281 */     if ((type != null) && (type.getType() == this.navigator.ref(CompositeStructure.class))) {
/*  282 */       return;
/*      */     }
/*      */     
/*  285 */     XmlSchemaGenerator<T, C, F, M>.Namespace n = getNamespace(tagName.getNamespaceURI()); XmlSchemaGenerator<T, C, F, M>.Namespace 
/*  286 */       tmp51_49 = n;tmp51_49.getClass();n.elementDecls.put(tagName.getLocalPart(), new XmlSchemaGenerator.Namespace.ElementWithType(tmp51_49, isNillable, type));
/*      */     
/*      */ 
/*  289 */     if (type != null) {
/*  290 */       n.addDependencyTo(type.getTypeName());
/*      */     }
/*      */   }
/*      */   
/*      */   public void write(SchemaOutputResolver resolver)
/*      */     throws IOException
/*      */   {
/*  297 */     if (resolver == null) {
/*  298 */       throw new IllegalArgumentException();
/*      */     }
/*      */     
/*  301 */     resolver = new FoolProofResolver(resolver);
/*      */     
/*  303 */     Map<XmlSchemaGenerator<T, C, F, M>.Namespace, Result> out = new HashMap();
/*      */     
/*      */ 
/*      */ 
/*  307 */     this.namespaces.remove("http://www.w3.org/2001/XMLSchema");
/*      */     
/*      */ 
/*      */ 
/*  311 */     for (XmlSchemaGenerator<T, C, F, M>.Namespace n : this.namespaces.values()) {
/*  312 */       Result output = resolver.createOutput(n.uri, "schema" + (out.size() + 1) + ".xsd");
/*  313 */       if (output != null) {
/*  314 */         out.put(n, output);
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*  319 */     for (XmlSchemaGenerator<T, C, F, M>.Namespace n : this.namespaces.values()) {
/*  320 */       Result result = (Result)out.get(n);
/*  321 */       if (result != null) {
/*  322 */         n.writeTo(result, out);
/*  323 */         if ((result instanceof StreamResult)) {
/*  324 */           OutputStream outputStream = ((StreamResult)result).getOutputStream();
/*  325 */           if (outputStream != null) {
/*  326 */             outputStream.close();
/*      */           } else {
/*  328 */             Writer writer = ((StreamResult)result).getWriter();
/*  329 */             if (writer != null) { writer.close();
/*      */             }
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private class Namespace
/*      */   {
/*      */     final String uri;
/*      */     
/*      */ 
/*      */ 
/*  347 */     private final Set<XmlSchemaGenerator<T, C, F, M>.Namespace> depends = new LinkedHashSet();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     private boolean selfReference;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  357 */     private final Set<ClassInfo<T, C>> classes = new LinkedHashSet();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  362 */     private final Set<EnumLeafInfo<T, C>> enums = new LinkedHashSet();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  367 */     private final Set<ArrayInfo<T, C>> arrays = new LinkedHashSet();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  372 */     private final MultiMap<String, NonElement<T, C>> attributeDecls = new MultiMap(XmlSchemaGenerator.this.stringType);
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  377 */     private final MultiMap<String, XmlSchemaGenerator<T, C, F, M>.Namespace.ElementDeclaration> elementDecls = new MultiMap(new ElementWithType(true, XmlSchemaGenerator.this.anyType));
/*      */     
/*      */     private Form attributeFormDefault;
/*      */     private Form elementFormDefault;
/*      */     
/*      */     public Namespace(String uri)
/*      */     {
/*  384 */       this.uri = uri;
/*  385 */       assert (!XmlSchemaGenerator.this.namespaces.containsKey(uri));
/*  386 */       XmlSchemaGenerator.this.namespaces.put(uri, this);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void processForeignNamespaces(PropertyInfo<T, C> p)
/*      */     {
/*  400 */       for (TypeInfo<T, C> t : p.ref()) {
/*  401 */         if ((t instanceof Element)) {
/*  402 */           addDependencyTo(((Element)t).getElementName());
/*      */         }
/*  404 */         if ((t instanceof NonElement)) {
/*  405 */           addDependencyTo(((NonElement)t).getTypeName());
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     private void addDependencyTo(@Nullable QName qname)
/*      */     {
/*  414 */       if (qname == null) { return;
/*      */       }
/*  416 */       String nsUri = qname.getNamespaceURI();
/*      */       
/*  418 */       if (nsUri.equals("http://www.w3.org/2001/XMLSchema"))
/*      */       {
/*  420 */         return;
/*      */       }
/*  422 */       if (nsUri.equals(this.uri)) {
/*  423 */         this.selfReference = true;
/*  424 */         return;
/*      */       }
/*      */       
/*      */ 
/*  428 */       this.depends.add(XmlSchemaGenerator.this.getNamespace(nsUri));
/*      */     }
/*      */     
/*      */     private void writeTo(Result result, Map<XmlSchemaGenerator<T, C, F, M>.Namespace, Result> out)
/*      */       throws IOException
/*      */     {
/*      */       try
/*      */       {
/*  436 */         Schema schema = (Schema)TXW.create(Schema.class, ResultFactory.createSerializer(result));
/*      */         
/*      */ 
/*  439 */         Map<String, String> xmlNs = XmlSchemaGenerator.this.types.getXmlNs(this.uri);
/*      */         
/*  441 */         for (Map.Entry<String, String> e : xmlNs.entrySet()) {
/*  442 */           schema._namespace((String)e.getValue(), (String)e.getKey());
/*      */         }
/*      */         
/*  445 */         this.attributeFormDefault = Form.get(XmlSchemaGenerator.this.types.getAttributeFormDefault(this.uri));
/*  446 */         this.attributeFormDefault.declare("attributeFormDefault", schema);
/*      */         
/*  448 */         this.elementFormDefault = Form.get(XmlSchemaGenerator.this.types.getElementFormDefault(this.uri));
/*      */         
/*  450 */         this.elementFormDefault.declare("elementFormDefault", schema);
/*      */         
/*      */ 
/*      */ 
/*      */ 
/*  455 */         if ((!xmlNs.containsValue("http://www.w3.org/2001/XMLSchema")) && (!xmlNs.containsKey("xs")))
/*      */         {
/*  457 */           schema._namespace("http://www.w3.org/2001/XMLSchema", "xs"); }
/*  458 */         schema.version("1.0");
/*      */         
/*  460 */         if (this.uri.length() != 0) {
/*  461 */           schema.targetNamespace(this.uri);
/*      */         }
/*      */         
/*      */ 
/*  465 */         for (XmlSchemaGenerator<T, C, F, M>.Namespace ns : this.depends) {
/*  466 */           schema._namespace(ns.uri);
/*      */         }
/*      */         
/*  469 */         if ((this.selfReference) && (this.uri.length() != 0))
/*      */         {
/*      */ 
/*  472 */           schema._namespace(this.uri, "tns");
/*      */         }
/*      */         
/*  475 */         schema._pcdata("\n");
/*      */         
/*      */ 
/*  478 */         for (XmlSchemaGenerator<T, C, F, M>.Namespace n : this.depends) {
/*  479 */           Import imp = schema._import();
/*  480 */           if (n.uri.length() != 0)
/*  481 */             imp.namespace(n.uri);
/*  482 */           imp.schemaLocation(XmlSchemaGenerator.relativize(((Result)out.get(n)).getSystemId(), result.getSystemId()));
/*  483 */           schema._pcdata("\n");
/*      */         }
/*      */         
/*      */ 
/*  487 */         for (Map.Entry<String, XmlSchemaGenerator<T, C, F, M>.Namespace.ElementDeclaration> e : this.elementDecls.entrySet()) {
/*  488 */           ((ElementDeclaration)e.getValue()).writeTo((String)e.getKey(), schema);
/*  489 */           schema._pcdata("\n");
/*      */         }
/*  491 */         for (ClassInfo<T, C> c : this.classes)
/*  492 */           if (c.getTypeName() != null)
/*      */           {
/*      */ 
/*      */ 
/*  496 */             if (this.uri.equals(c.getTypeName().getNamespaceURI()))
/*  497 */               writeClass(c, schema);
/*  498 */             schema._pcdata("\n");
/*      */           }
/*  500 */         for (EnumLeafInfo<T, C> e : this.enums)
/*  501 */           if (e.getTypeName() != null)
/*      */           {
/*      */ 
/*      */ 
/*  505 */             if (this.uri.equals(e.getTypeName().getNamespaceURI()))
/*  506 */               writeEnum(e, schema);
/*  507 */             schema._pcdata("\n");
/*      */           }
/*  509 */         for (ArrayInfo<T, C> a : this.arrays) {
/*  510 */           writeArray(a, schema);
/*  511 */           schema._pcdata("\n");
/*      */         }
/*  513 */         for (Map.Entry<String, NonElement<T, C>> e : this.attributeDecls.entrySet()) {
/*  514 */           TopLevelAttribute a = schema.attribute();
/*  515 */           a.name((String)e.getKey());
/*  516 */           writeTypeRef(a, (NonElement)e.getValue(), "type");
/*  517 */           schema._pcdata("\n");
/*      */         }
/*      */         
/*      */ 
/*  521 */         schema.commit();
/*      */       } catch (TxwException e) {
/*  523 */         XmlSchemaGenerator.logger.log(Level.INFO, e.getMessage(), e);
/*  524 */         throw new IOException(e.getMessage());
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void writeTypeRef(TypeHost th, NonElementRef<T, C> typeRef, String refAttName)
/*      */     {
/*  541 */       switch (XmlSchemaGenerator.2.$SwitchMap$com$sun$xml$bind$v2$model$core$ID[typeRef.getSource().id().ordinal()]) {
/*      */       case 1: 
/*  543 */         th._attribute(refAttName, new QName("http://www.w3.org/2001/XMLSchema", "ID"));
/*  544 */         return;
/*      */       case 2: 
/*  546 */         th._attribute(refAttName, new QName("http://www.w3.org/2001/XMLSchema", "IDREF")); return;
/*      */       
/*      */       case 3: 
/*      */         break;
/*      */       
/*      */       default: 
/*  552 */         throw new IllegalStateException();
/*      */       }
/*      */       
/*      */       
/*  556 */       MimeType mimeType = typeRef.getSource().getExpectedMimeType();
/*  557 */       if (mimeType != null) {
/*  558 */         th._attribute(new QName("http://www.w3.org/2005/05/xmlmime", "expectedContentTypes", "xmime"), mimeType.toString());
/*      */       }
/*      */       
/*      */ 
/*  562 */       if (generateSwaRefAdapter(typeRef)) {
/*  563 */         th._attribute(refAttName, new QName("http://ws-i.org/profiles/basic/1.1/xsd", "swaRef", "ref"));
/*  564 */         return;
/*      */       }
/*      */       
/*      */ 
/*  568 */       if (typeRef.getSource().getSchemaType() != null) {
/*  569 */         th._attribute(refAttName, typeRef.getSource().getSchemaType());
/*  570 */         return;
/*      */       }
/*      */       
/*      */ 
/*      */ 
/*  575 */       writeTypeRef(th, typeRef.getTarget(), refAttName);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */     private boolean generateSwaRefAdapter(NonElementRef<T, C> typeRef)
/*      */     {
/*  583 */       Adapter<T, C> adapter = typeRef.getSource().getAdapter();
/*  584 */       if (adapter == null) return false;
/*  585 */       Object o = XmlSchemaGenerator.this.navigator.asDecl(SwaRefAdapter.class);
/*  586 */       if (o == null) return false;
/*  587 */       return o.equals(adapter.adapterType);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void writeTypeRef(TypeHost th, NonElement<T, C> type, String refAttName)
/*      */     {
/*  603 */       if (type.getTypeName() == null) {
/*  604 */         if ((type instanceof ClassInfo)) {
/*  605 */           writeClass((ClassInfo)type, th);
/*      */         } else {
/*  607 */           writeEnum((EnumLeafInfo)type, (SimpleTypeHost)th);
/*      */         }
/*      */       } else {
/*  610 */         th._attribute(refAttName, type.getTypeName());
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     private void writeArray(ArrayInfo<T, C> a, Schema schema)
/*      */     {
/*  618 */       ComplexType ct = schema.complexType().name(a.getTypeName().getLocalPart());
/*  619 */       ct._final("#all");
/*  620 */       LocalElement le = ct.sequence().element().name("item");
/*  621 */       le.type(a.getItemType().getTypeName());
/*  622 */       le.minOccurs(0).maxOccurs("unbounded");
/*  623 */       le.nillable(true);
/*  624 */       ct.commit();
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     private void writeEnum(EnumLeafInfo<T, C> e, SimpleTypeHost th)
/*      */     {
/*  631 */       SimpleType st = th.simpleType();
/*  632 */       writeName(e, st);
/*      */       
/*  634 */       SimpleRestrictionModel base = st.restriction();
/*  635 */       writeTypeRef(base, e.getBaseType(), "base");
/*      */       
/*  637 */       for (EnumConstant c : e.getConstants()) {
/*  638 */         base.enumeration().value(c.getLexicalValue());
/*      */       }
/*  640 */       st.commit();
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void writeClass(ClassInfo<T, C> c, TypeHost parent)
/*      */     {
/*  651 */       if (containsValueProp(c)) {
/*  652 */         if (c.getProperties().size() == 1)
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  658 */           ValuePropertyInfo<T, C> vp = (ValuePropertyInfo)c.getProperties().get(0);
/*  659 */           SimpleType st = ((SimpleTypeHost)parent).simpleType();
/*  660 */           writeName(c, st);
/*  661 */           if (vp.isCollection()) {
/*  662 */             writeTypeRef(st.list(), vp.getTarget(), "itemType");
/*      */           } else {
/*  664 */             writeTypeRef(st.restriction(), vp.getTarget(), "base");
/*      */           }
/*  666 */           return;
/*      */         }
/*      */         
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  680 */         ComplexType ct = ((ComplexTypeHost)parent).complexType();
/*  681 */         writeName(c, ct);
/*  682 */         if (c.isFinal()) {
/*  683 */           ct._final("extension restriction");
/*      */         }
/*  685 */         SimpleExtension se = ct.simpleContent().extension();
/*  686 */         se.block();
/*  687 */         for (PropertyInfo<T, C> p : c.getProperties()) {
/*  688 */           switch (XmlSchemaGenerator.2.$SwitchMap$com$sun$xml$bind$v2$model$core$PropertyKind[p.kind().ordinal()]) {
/*      */           case 1: 
/*  690 */             handleAttributeProp((AttributePropertyInfo)p, se);
/*  691 */             break;
/*      */           case 2: 
/*  693 */             TODO.checkSpec("what if vp.isCollection() == true?");
/*  694 */             ValuePropertyInfo vp = (ValuePropertyInfo)p;
/*  695 */             se.base(vp.getTarget().getTypeName());
/*  696 */             break;
/*      */           case 3: 
/*      */           case 4: 
/*      */           default: 
/*  700 */             if (!$assertionsDisabled) throw new AssertionError();
/*  701 */             throw new IllegalStateException();
/*      */           }
/*      */         }
/*  704 */         se.commit();
/*      */         
/*  706 */         TODO.schemaGenerator("figure out what to do if bc != null");
/*  707 */         TODO.checkSpec("handle sec 8.9.5.2, bullet #4");
/*      */         
/*      */ 
/*      */ 
/*  711 */         return;
/*      */       }
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*  717 */       ComplexType ct = ((ComplexTypeHost)parent).complexType();
/*  718 */       writeName(c, ct);
/*  719 */       if (c.isFinal())
/*  720 */         ct._final("extension restriction");
/*  721 */       if (c.isAbstract()) {
/*  722 */         ct._abstract(true);
/*      */       }
/*      */       
/*  725 */       ct.block();
/*      */       
/*      */ 
/*  728 */       ExplicitGroup compositor = null;
/*      */       
/*      */ 
/*  731 */       AttrDecls contentModel = ct;
/*      */       
/*      */ 
/*  734 */       ClassInfo<T, C> bc = c.getBaseClass();
/*  735 */       if (bc != null) {
/*  736 */         ComplexExtension ce = ct.complexContent().extension();
/*  737 */         contentModel = ce;
/*      */         
/*  739 */         ce.base(bc.getTypeName());
/*      */         
/*      */ 
/*  742 */         if (c.isOrdered()) {
/*  743 */           compositor = ce.sequence();
/*      */         } else {
/*  745 */           compositor = ce.all();
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*  750 */       if (c.hasProperties()) {
/*  751 */         if (compositor == null)
/*      */         {
/*  753 */           if (c.isOrdered()) {
/*  754 */             compositor = ct.sequence();
/*      */           } else {
/*  756 */             compositor = ct.all();
/*      */           }
/*      */         }
/*      */         
/*      */ 
/*      */ 
/*  762 */         compositor.block();
/*      */         
/*  764 */         for (PropertyInfo<T, C> p : c.getProperties())
/*      */         {
/*  766 */           if (((p instanceof ReferencePropertyInfo)) && (((ReferencePropertyInfo)p).isMixed())) {
/*  767 */             ct.mixed(true);
/*      */           }
/*  769 */           writeProperty(p, contentModel, compositor);
/*      */         }
/*      */         
/*  772 */         compositor.commit();
/*      */       }
/*      */       
/*      */ 
/*  776 */       if (c.hasAttributeWildcard())
/*      */       {
/*  778 */         contentModel.anyAttribute().namespace("##other").processContents("skip");
/*      */       }
/*      */       
/*      */ 
/*  782 */       ct.commit();
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     private void writeName(NonElement<T, C> c, TypedXmlWriter xw)
/*      */     {
/*  789 */       QName tn = c.getTypeName();
/*  790 */       if (tn != null)
/*  791 */         xw._attribute("name", tn.getLocalPart());
/*      */     }
/*      */     
/*      */     private boolean containsValueProp(ClassInfo<T, C> c) {
/*  795 */       for (PropertyInfo p : c.getProperties()) {
/*  796 */         if ((p instanceof ValuePropertyInfo)) return true;
/*      */       }
/*  798 */       return false;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     private void writeProperty(PropertyInfo<T, C> p, AttrDecls attr, ExplicitGroup compositor)
/*      */     {
/*  805 */       switch (XmlSchemaGenerator.2.$SwitchMap$com$sun$xml$bind$v2$model$core$PropertyKind[p.kind().ordinal()]) {
/*      */       case 3: 
/*  807 */         handleElementProp((ElementPropertyInfo)p, compositor);
/*  808 */         break;
/*      */       case 1: 
/*  810 */         handleAttributeProp((AttributePropertyInfo)p, attr);
/*  811 */         break;
/*      */       case 4: 
/*  813 */         handleReferenceProp((ReferencePropertyInfo)p, compositor);
/*  814 */         break;
/*      */       case 5: 
/*  816 */         handleMapProp((MapPropertyInfo)p, compositor);
/*  817 */         break;
/*      */       
/*      */       case 2: 
/*  820 */         if (!$assertionsDisabled) throw new AssertionError();
/*  821 */         throw new IllegalStateException();
/*      */       
/*      */       default: 
/*  824 */         if (!$assertionsDisabled) throw new AssertionError();
/*  825 */         throw new IllegalStateException();
/*      */       }
/*      */       
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void handleElementProp(ElementPropertyInfo<T, C> ep, ExplicitGroup compositor)
/*      */     {
/*  840 */       QName ename = ep.getXmlName();
/*  841 */       Occurs occurs = null;
/*      */       
/*  843 */       if (ep.isValueList()) {
/*  844 */         TypeRef<T, C> t = (TypeRef)ep.getTypes().get(0);
/*  845 */         LocalElement e = compositor.element();
/*      */         
/*  847 */         QName tn = t.getTagName();
/*  848 */         e.name(tn.getLocalPart());
/*  849 */         com.sun.xml.bind.v2.schemagen.xmlschema.List lst = e.simpleType().list();
/*  850 */         writeTypeRef(lst, t, "itemType");
/*  851 */         this.elementFormDefault.writeForm(e, tn);
/*  852 */         return;
/*      */       }
/*      */       
/*  855 */       if (ep.isCollection()) {
/*  856 */         if (ename != null) {
/*  857 */           LocalElement e = compositor.element();
/*  858 */           if ((ename.getNamespaceURI().length() > 0) && 
/*  859 */             (!ename.getNamespaceURI().equals(this.uri)))
/*      */           {
/*      */ 
/*  862 */             e.ref(new QName(ename.getNamespaceURI(), ename.getLocalPart()));
/*  863 */             return;
/*      */           }
/*      */           
/*  866 */           this.elementFormDefault.writeForm(e, ename);
/*      */           
/*  868 */           ComplexType p = e.name(ename.getLocalPart()).complexType();
/*  869 */           if (ep.isCollectionNillable()) {
/*  870 */             e.nillable(true);
/*      */           } else {
/*  872 */             e.minOccurs(0);
/*      */           }
/*  874 */           if (ep.getTypes().size() == 1) {
/*  875 */             compositor = p.sequence();
/*      */           } else {
/*  877 */             compositor = p.choice();
/*  878 */             occurs = compositor;
/*      */           }
/*      */         }
/*  881 */         else if (ep.getTypes().size() > 1) {
/*  882 */           compositor = compositor.choice();
/*  883 */           occurs = compositor;
/*      */         }
/*      */         
/*      */       }
/*  887 */       else if (ep.getTypes().size() > 1) {
/*  888 */         compositor = compositor.choice();
/*  889 */         occurs = compositor;
/*      */       }
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*  895 */       for (TypeRef<T, C> t : ep.getTypes()) {
/*  896 */         LocalElement e = compositor.element();
/*  897 */         if (occurs == null) occurs = e;
/*  898 */         QName tn = t.getTagName();
/*      */         
/*  900 */         if ((canBeDirectElementRef(t, tn)) || ((!tn.getNamespaceURI().equals(this.uri)) && (tn.getNamespaceURI().length() > 0))) {
/*  901 */           e.ref(tn);
/*      */         } else {
/*  903 */           e.name(tn.getLocalPart());
/*  904 */           writeTypeRef(e, t, "type");
/*  905 */           this.elementFormDefault.writeForm(e, tn);
/*      */         }
/*      */         
/*  908 */         if (t.isNillable()) {
/*  909 */           e.nillable(true);
/*      */         }
/*  911 */         if (t.getDefaultValue() != null) {
/*  912 */           e._default(t.getDefaultValue());
/*      */         }
/*      */       }
/*  915 */       if (ep.isCollection()) {
/*  916 */         occurs.maxOccurs("unbounded");
/*      */       }
/*  918 */       if (!ep.isRequired())
/*      */       {
/*  920 */         occurs.minOccurs(0);
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private boolean canBeDirectElementRef(TypeRef<T, C> t, QName tn)
/*      */     {
/*  931 */       if ((t.isNillable()) || (t.getDefaultValue() != null))
/*      */       {
/*  933 */         return false;
/*      */       }
/*  935 */       if ((t.getTarget() instanceof Element)) {
/*  936 */         Element te = (Element)t.getTarget();
/*  937 */         QName targetTagName = te.getElementName();
/*  938 */         return (targetTagName != null) && (targetTagName.equals(tn));
/*      */       }
/*      */       
/*  941 */       return false;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void handleAttributeProp(AttributePropertyInfo<T, C> ap, AttrDecls attr)
/*      */     {
/*  974 */       LocalAttribute localAttribute = attr.attribute();
/*      */       
/*  976 */       String attrURI = ap.getXmlName().getNamespaceURI();
/*  977 */       if ((attrURI.equals("")) || (attrURI.equals(this.uri))) {
/*  978 */         localAttribute.name(ap.getXmlName().getLocalPart());
/*      */         String refAtt;
/*      */         TypeHost th;
/*  981 */         String refAtt; if (ap.isCollection()) {
/*  982 */           TypeHost th = localAttribute.simpleType().list();
/*  983 */           refAtt = "itemType";
/*      */         } else {
/*  985 */           th = localAttribute;
/*  986 */           refAtt = "type";
/*      */         }
/*  988 */         writeTypeRef(th, ap, refAtt);
/*      */         
/*  990 */         this.attributeFormDefault.writeForm(localAttribute, ap.getXmlName());
/*      */       } else {
/*  992 */         localAttribute.ref(ap.getXmlName());
/*      */       }
/*      */       
/*  995 */       if (ap.isRequired())
/*      */       {
/*  997 */         localAttribute.use("required");
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void handleReferenceProp(ReferencePropertyInfo<T, C> rp, ExplicitGroup compositor)
/*      */     {
/* 1012 */       QName ename = rp.getXmlName();
/* 1013 */       Occurs occurs = null;
/*      */       
/* 1015 */       if (rp.isCollection()) {
/* 1016 */         if (ename != null) {
/* 1017 */           LocalElement e = compositor.element();
/* 1018 */           ComplexType p = e.name(ename.getLocalPart()).complexType();
/* 1019 */           this.elementFormDefault.writeForm(e, ename);
/* 1020 */           if (rp.isCollectionNillable())
/* 1021 */             e.nillable(true);
/* 1022 */           if (rp.getElements().size() == 1) {
/* 1023 */             compositor = p.sequence();
/*      */           } else {
/* 1025 */             compositor = p.choice();
/* 1026 */             occurs = compositor;
/*      */           }
/*      */         }
/* 1029 */         else if (rp.getElements().size() > 1) {
/* 1030 */           compositor = compositor.choice();
/* 1031 */           occurs = compositor;
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*      */ 
/* 1037 */       TODO.checkSpec("should we loop in the case of a non-collection ep?");
/* 1038 */       for (Element<T, C> e : rp.getElements()) {
/* 1039 */         LocalElement eref = compositor.element();
/* 1040 */         if (occurs == null) { occurs = eref;
/*      */         }
/* 1042 */         QName en = e.getElementName();
/* 1043 */         if (e.getScope() != null)
/*      */         {
/* 1045 */           boolean qualified = en.getNamespaceURI().equals(this.uri);
/* 1046 */           boolean unqualified = en.getNamespaceURI().equals("");
/* 1047 */           if ((qualified) || (unqualified))
/*      */           {
/*      */ 
/*      */ 
/* 1051 */             if (unqualified) {
/* 1052 */               if (this.elementFormDefault.isEffectivelyQualified) {
/* 1053 */                 eref.form("unqualified");
/*      */               }
/* 1055 */             } else if (!this.elementFormDefault.isEffectivelyQualified) {
/* 1056 */               eref.form("qualified");
/*      */             }
/*      */             
/* 1059 */             eref.name(en.getLocalPart());
/*      */             
/*      */ 
/* 1062 */             if ((e instanceof ClassInfo)) {
/* 1063 */               writeTypeRef(eref, (ClassInfo)e, "type");
/* 1064 */               continue; }
/* 1065 */             writeTypeRef(eref, ((ElementInfo)e).getContentType(), "type");
/*      */             
/* 1067 */             continue;
/*      */           }
/*      */         }
/* 1070 */         eref.ref(en);
/*      */       }
/*      */       
/* 1073 */       WildcardMode wc = rp.getWildcard();
/* 1074 */       if (wc != null) {
/* 1075 */         Any any = compositor.any();
/* 1076 */         String pcmode = XmlSchemaGenerator.getProcessContentsModeName(wc);
/* 1077 */         if (pcmode != null) any.processContents(pcmode);
/* 1078 */         TODO.schemaGenerator("generate @namespace ???");
/* 1079 */         if (occurs == null) { occurs = any;
/*      */         }
/*      */       }
/* 1082 */       if (rp.isCollection()) {
/* 1083 */         occurs.maxOccurs("unbounded");
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     private void handleMapProp(MapPropertyInfo<T, C> mp, ExplicitGroup compositor)
/*      */     {
/* 1095 */       QName ename = mp.getXmlName();
/*      */       
/* 1097 */       LocalElement e = compositor.element();
/* 1098 */       this.elementFormDefault.writeForm(e, ename);
/* 1099 */       if (mp.isCollectionNillable())
/* 1100 */         e.nillable(true);
/* 1101 */       ComplexType p = e.name(ename.getLocalPart()).complexType();
/*      */       
/*      */ 
/*      */ 
/* 1105 */       e = p.sequence().element();
/* 1106 */       e.name("entry").minOccurs(0).maxOccurs("unbounded");
/*      */       
/* 1108 */       ExplicitGroup seq = e.complexType().sequence();
/* 1109 */       writeKeyOrValue(seq, "key", mp.getKeyType());
/* 1110 */       writeKeyOrValue(seq, "value", mp.getValueType());
/*      */     }
/*      */     
/*      */     private void writeKeyOrValue(ExplicitGroup seq, String tagName, NonElement<T, C> typeRef) {
/* 1114 */       LocalElement key = seq.element().name(tagName);
/* 1115 */       key.minOccurs(0);
/* 1116 */       writeTypeRef(key, typeRef, "type");
/*      */     }
/*      */     
/*      */     public void addGlobalAttribute(AttributePropertyInfo<T, C> ap) {
/* 1120 */       this.attributeDecls.put(ap.getXmlName().getLocalPart(), ap.getTarget());
/* 1121 */       addDependencyTo(ap.getTarget().getTypeName());
/*      */     }
/*      */     
/*      */     public void addGlobalElement(TypeRef<T, C> tref) {
/* 1125 */       this.elementDecls.put(tref.getTagName().getLocalPart(), new ElementWithType(false, tref.getTarget()));
/* 1126 */       addDependencyTo(tref.getTarget().getTypeName());
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     class ElementWithType
/*      */       extends XmlSchemaGenerator.Namespace.ElementDeclaration
/*      */     {
/*      */       private final boolean nillable;
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       private final NonElement<T, C> type;
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       public ElementWithType(NonElement<T, C> nillable)
/*      */       {
/* 1164 */         super();
/* 1165 */         this.type = type;
/* 1166 */         this.nillable = nillable;
/*      */       }
/*      */       
/*      */       public void writeTo(String localName, Schema schema) {
/* 1170 */         TopLevelElement e = schema.element().name(localName);
/* 1171 */         if (this.nillable)
/* 1172 */           e.nillable(true);
/* 1173 */         if (this.type != null) {
/* 1174 */           XmlSchemaGenerator.Namespace.this.writeTypeRef(e, this.type, "type");
/*      */         } else {
/* 1176 */           e.complexType();
/*      */         }
/* 1178 */         e.commit();
/*      */       }
/*      */       
/*      */       public boolean equals(Object o) {
/* 1182 */         if (this == o) return true;
/* 1183 */         if ((o == null) || (getClass() != o.getClass())) { return false;
/*      */         }
/* 1185 */         XmlSchemaGenerator<T, C, F, M>.Namespace.ElementWithType that = (ElementWithType)o;
/* 1186 */         return this.type.equals(that.type);
/*      */       }
/*      */       
/*      */ 
/* 1190 */       public int hashCode() { return this.type.hashCode(); }
/*      */     }
/*      */     
/*      */     abstract class ElementDeclaration { ElementDeclaration() {}
/*      */       
/*      */       public abstract boolean equals(Object paramObject);
/*      */       
/*      */       public abstract int hashCode();
/*      */       
/*      */       public abstract void writeTo(String paramString, Schema paramSchema);
/*      */     } }
/*      */   
/* 1202 */   private static String getProcessContentsModeName(WildcardMode wc) { switch (wc) {
/*      */     case LAX: 
/*      */     case SKIP: 
/* 1205 */       return wc.name().toLowerCase();
/*      */     case STRICT: 
/* 1207 */       return null;
/*      */     }
/* 1209 */     throw new IllegalStateException();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected static String relativize(String uri, String baseUri)
/*      */   {
/*      */     try
/*      */     {
/* 1234 */       assert (uri != null);
/*      */       
/* 1236 */       if (baseUri == null) { return uri;
/*      */       }
/* 1238 */       URI theUri = new URI(Util.escapeURI(uri));
/* 1239 */       URI theBaseUri = new URI(Util.escapeURI(baseUri));
/*      */       
/* 1241 */       if ((theUri.isOpaque()) || (theBaseUri.isOpaque())) {
/* 1242 */         return uri;
/*      */       }
/* 1244 */       if ((!Util.equalsIgnoreCase(theUri.getScheme(), theBaseUri.getScheme())) || (!Util.equal(theUri.getAuthority(), theBaseUri.getAuthority())))
/*      */       {
/* 1246 */         return uri;
/*      */       }
/* 1248 */       String uriPath = theUri.getPath();
/* 1249 */       String basePath = theBaseUri.getPath();
/*      */       
/*      */ 
/* 1252 */       if (!basePath.endsWith("/")) {
/* 1253 */         basePath = Util.normalizeUriPath(basePath);
/*      */       }
/*      */       
/* 1256 */       if (uriPath.equals(basePath)) {
/* 1257 */         return ".";
/*      */       }
/* 1259 */       String relPath = calculateRelativePath(uriPath, basePath);
/*      */       
/* 1261 */       if (relPath == null)
/* 1262 */         return uri;
/* 1263 */       StringBuffer relUri = new StringBuffer();
/* 1264 */       relUri.append(relPath);
/* 1265 */       if (theUri.getQuery() != null)
/* 1266 */         relUri.append('?').append(theUri.getQuery());
/* 1267 */       if (theUri.getFragment() != null) {
/* 1268 */         relUri.append('#').append(theUri.getFragment());
/*      */       }
/* 1270 */       return relUri.toString();
/*      */     } catch (URISyntaxException e) {
/* 1272 */       throw new InternalError("Error escaping one of these uris:\n\t" + uri + "\n\t" + baseUri);
/*      */     }
/*      */   }
/*      */   
/*      */   private static String calculateRelativePath(String uri, String base) {
/* 1277 */     if (base == null) {
/* 1278 */       return null;
/*      */     }
/* 1280 */     if (uri.startsWith(base)) {
/* 1281 */       return uri.substring(base.length());
/*      */     }
/* 1283 */     return "../" + calculateRelativePath(uri, Util.getParentUriPath(base));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1291 */   private static final Comparator<String> NAMESPACE_COMPARATOR = new Comparator() {
/*      */     public int compare(String lhs, String rhs) {
/* 1293 */       return -lhs.compareTo(rhs);
/*      */     }
/*      */   };
/*      */   private static final String newline = "\n";
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\schemagen\XmlSchemaGenerator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */