/*     */ package com.sun.xml.txw2;
/*     */ 
/*     */ import com.sun.xml.txw2.annotation.XmlAttribute;
/*     */ import com.sun.xml.txw2.annotation.XmlCDATA;
/*     */ import com.sun.xml.txw2.annotation.XmlElement;
/*     */ import com.sun.xml.txw2.annotation.XmlNamespace;
/*     */ import com.sun.xml.txw2.annotation.XmlValue;
/*     */ import java.lang.reflect.InvocationHandler;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Proxy;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class ContainerElement
/*     */   implements InvocationHandler, TypedXmlWriter
/*     */ {
/*     */   final Document document;
/*     */   private final Class<? extends TypedXmlWriter> facadeType;
/*     */   StartTag startTag;
/*  32 */   final EndTag endTag = new EndTag();
/*     */   
/*     */ 
/*     */ 
/*     */   private final String nsUri;
/*     */   
/*     */ 
/*     */ 
/*     */   private Content tail;
/*     */   
/*     */ 
/*     */ 
/*     */   private ContainerElement prevOpen;
/*     */   
/*     */ 
/*     */   private ContainerElement nextOpen;
/*     */   
/*     */ 
/*     */   private final ContainerElement parent;
/*     */   
/*     */ 
/*     */   private ContainerElement lastOpenChild;
/*     */   
/*     */ 
/*     */   private boolean blocked;
/*     */   
/*     */ 
/*     */ 
/*     */   public ContainerElement(Document document, ContainerElement parent, String nsUri, String localName, Class<? extends TypedXmlWriter> facadeType)
/*     */   {
/*  62 */     this.parent = parent;
/*  63 */     this.document = document;
/*  64 */     this.facadeType = facadeType;
/*  65 */     this.nsUri = nsUri;
/*  66 */     this.startTag = new StartTag(this, nsUri, localName);
/*  67 */     this.tail = this.startTag;
/*     */     
/*  69 */     if (isRoot())
/*  70 */       document.setFirstContent(this.startTag);
/*     */   }
/*     */   
/*     */   private boolean isRoot() {
/*  74 */     return this.parent == null;
/*     */   }
/*     */   
/*     */   private boolean isCommitted() {
/*  78 */     return this.tail == null;
/*     */   }
/*     */   
/*     */   public Document getDocument() {
/*  82 */     return this.document;
/*     */   }
/*     */   
/*     */   boolean isBlocked() {
/*  86 */     return (this.blocked) && (!isCommitted());
/*     */   }
/*     */   
/*     */   public void block() {
/*  90 */     this.blocked = true;
/*     */   }
/*     */   
/*     */   public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
/*  94 */     if (method.getDeclaringClass() == TypedXmlWriter.class) {
/*     */       try
/*     */       {
/*  97 */         return method.invoke(this, args);
/*     */       } catch (InvocationTargetException e) {
/*  99 */         throw e.getTargetException();
/*     */       }
/*     */     }
/*     */     
/* 103 */     XmlAttribute xa = (XmlAttribute)method.getAnnotation(XmlAttribute.class);
/* 104 */     XmlValue xv = (XmlValue)method.getAnnotation(XmlValue.class);
/* 105 */     XmlElement xe = (XmlElement)method.getAnnotation(XmlElement.class);
/*     */     
/*     */ 
/* 108 */     if (xa != null) {
/* 109 */       if ((xv != null) || (xe != null)) {
/* 110 */         throw new IllegalAnnotationException(method.toString());
/*     */       }
/* 112 */       addAttribute(xa, method, args);
/* 113 */       return proxy;
/*     */     }
/* 115 */     if (xv != null) {
/* 116 */       if ((xv != null) || (xe != null)) {
/* 117 */         throw new IllegalAnnotationException(method.toString());
/*     */       }
/* 119 */       _pcdata(args);
/* 120 */       return proxy;
/*     */     }
/*     */     
/* 123 */     return addElement(xe, method, args);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private void addAttribute(XmlAttribute xa, Method method, Object[] args)
/*     */   {
/* 130 */     assert (xa != null);
/*     */     
/* 132 */     checkStartTag();
/*     */     
/* 134 */     String localName = xa.value();
/* 135 */     if (xa.value().length() == 0) {
/* 136 */       localName = method.getName();
/*     */     }
/* 138 */     _attribute(xa.ns(), localName, args);
/*     */   }
/*     */   
/*     */   private void checkStartTag() {
/* 142 */     if (this.startTag == null) {
/* 143 */       throw new IllegalStateException("start tag has already been written");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private Object addElement(XmlElement e, Method method, Object[] args)
/*     */   {
/* 150 */     Class<?> rt = method.getReturnType();
/*     */     
/*     */ 
/* 153 */     String nsUri = "##default";
/* 154 */     String localName = method.getName();
/*     */     
/* 156 */     if (e != null)
/*     */     {
/* 158 */       if (e.value().length() != 0)
/* 159 */         localName = e.value();
/* 160 */       nsUri = e.ns();
/*     */     }
/*     */     
/* 163 */     if (nsUri.equals("##default"))
/*     */     {
/* 165 */       Class<?> c = method.getDeclaringClass();
/* 166 */       XmlElement ce = (XmlElement)c.getAnnotation(XmlElement.class);
/* 167 */       if (ce != null) {
/* 168 */         nsUri = ce.ns();
/*     */       }
/*     */       
/* 171 */       if (nsUri.equals("##default"))
/*     */       {
/* 173 */         nsUri = getNamespace(c.getPackage());
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 178 */     if (rt == Void.TYPE)
/*     */     {
/*     */ 
/* 181 */       boolean isCDATA = method.getAnnotation(XmlCDATA.class) != null;
/*     */       
/* 183 */       StartTag st = new StartTag(this.document, nsUri, localName);
/* 184 */       addChild(st);
/* 185 */       for (Object arg : args) { Text text;
/*     */         Text text;
/* 187 */         if (isCDATA) text = new Cdata(this.document, st, arg); else
/* 188 */           text = new Pcdata(this.document, st, arg);
/* 189 */         addChild(text);
/*     */       }
/* 191 */       addChild(new EndTag());
/* 192 */       return null;
/*     */     }
/* 194 */     if (TypedXmlWriter.class.isAssignableFrom(rt))
/*     */     {
/* 196 */       return _element(nsUri, localName, rt);
/*     */     }
/*     */     
/* 199 */     throw new IllegalSignatureException("Illegal return type: " + rt);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private String getNamespace(Package pkg)
/*     */   {
/* 206 */     if (pkg == null) { return "";
/*     */     }
/*     */     
/* 209 */     XmlNamespace ns = (XmlNamespace)pkg.getAnnotation(XmlNamespace.class);
/* 210 */     String nsUri; String nsUri; if (ns != null) {
/* 211 */       nsUri = ns.value();
/*     */     } else
/* 213 */       nsUri = "";
/* 214 */     return nsUri;
/*     */   }
/*     */   
/*     */   public Object createFacade() {
/* 218 */     return Proxy.newProxyInstance(this.facadeType.getClassLoader(), new Class[] { this.facadeType }, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private void addChild(Content child)
/*     */   {
/* 225 */     this.tail.setNext(this.document, child);
/* 226 */     this.tail = child;
/*     */   }
/*     */   
/*     */   public void commit() {
/* 230 */     commit(true);
/*     */   }
/*     */   
/*     */   public void commit(boolean includingAllPredecessors) {
/* 234 */     _commit(includingAllPredecessors);
/* 235 */     this.document.flush();
/*     */   }
/*     */   
/*     */   private void _commit(boolean includingAllPredecessors) {
/* 239 */     if (isCommitted()) { return;
/*     */     }
/* 241 */     addChild(this.endTag);
/* 242 */     if (isRoot())
/* 243 */       addChild(new EndDocument());
/* 244 */     this.tail = null;
/*     */     
/*     */ 
/* 247 */     if (includingAllPredecessors) {
/* 248 */       for (ContainerElement e = this; e != null; e = e.parent) {
/* 249 */         while (e.prevOpen != null) {
/* 250 */           e.prevOpen._commit(false);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 257 */     while (this.lastOpenChild != null) {
/* 258 */       this.lastOpenChild._commit(false);
/*     */     }
/*     */     
/* 261 */     if (this.parent != null) {
/* 262 */       if (this.parent.lastOpenChild == this) {
/* 263 */         assert (this.nextOpen == null) : "this must be the last one";
/* 264 */         this.parent.lastOpenChild = this.prevOpen;
/*     */       } else {
/* 266 */         assert (this.nextOpen.prevOpen == this);
/* 267 */         this.nextOpen.prevOpen = this.prevOpen;
/*     */       }
/* 269 */       if (this.prevOpen != null) {
/* 270 */         assert (this.prevOpen.nextOpen == this);
/* 271 */         this.prevOpen.nextOpen = this.nextOpen;
/*     */       }
/*     */     }
/*     */     
/* 275 */     this.nextOpen = null;
/* 276 */     this.prevOpen = null;
/*     */   }
/*     */   
/*     */   public void _attribute(String localName, Object value) {
/* 280 */     _attribute("", localName, value);
/*     */   }
/*     */   
/*     */   public void _attribute(String nsUri, String localName, Object value) {
/* 284 */     checkStartTag();
/* 285 */     this.startTag.addAttribute(nsUri, localName, value);
/*     */   }
/*     */   
/*     */   public void _attribute(QName attributeName, Object value) {
/* 289 */     _attribute(attributeName.getNamespaceURI(), attributeName.getLocalPart(), value);
/*     */   }
/*     */   
/*     */   public void _namespace(String uri) {
/* 293 */     _namespace(uri, false);
/*     */   }
/*     */   
/*     */   public void _namespace(String uri, String prefix) {
/* 297 */     if (prefix == null)
/* 298 */       throw new IllegalArgumentException();
/* 299 */     checkStartTag();
/* 300 */     this.startTag.addNamespaceDecl(uri, prefix, false);
/*     */   }
/*     */   
/*     */   public void _namespace(String uri, boolean requirePrefix) {
/* 304 */     checkStartTag();
/* 305 */     this.startTag.addNamespaceDecl(uri, null, requirePrefix);
/*     */   }
/*     */   
/*     */ 
/*     */   public void _pcdata(Object value)
/*     */   {
/* 311 */     addChild(new Pcdata(this.document, this.startTag, value));
/*     */   }
/*     */   
/*     */   public void _cdata(Object value) {
/* 315 */     addChild(new Cdata(this.document, this.startTag, value));
/*     */   }
/*     */   
/*     */   public void _comment(Object value) throws UnsupportedOperationException {
/* 319 */     addChild(new Comment(this.document, this.startTag, value));
/*     */   }
/*     */   
/*     */   public <T extends TypedXmlWriter> T _element(String localName, Class<T> contentModel) {
/* 323 */     return _element(this.nsUri, localName, contentModel);
/*     */   }
/*     */   
/*     */   public <T extends TypedXmlWriter> T _element(QName tagName, Class<T> contentModel) {
/* 327 */     return _element(tagName.getNamespaceURI(), tagName.getLocalPart(), contentModel);
/*     */   }
/*     */   
/*     */   public <T extends TypedXmlWriter> T _element(Class<T> contentModel) {
/* 331 */     return _element(TXW.getTagName(contentModel), contentModel);
/*     */   }
/*     */   
/*     */   public <T extends TypedXmlWriter> T _element(String nsUri, String localName, Class<T> contentModel) {
/* 335 */     ContainerElement child = new ContainerElement(this.document, this, nsUri, localName, contentModel);
/* 336 */     addChild(child.startTag);
/* 337 */     this.tail = child.endTag;
/*     */     
/*     */ 
/* 340 */     if (this.lastOpenChild != null) {
/* 341 */       assert (this.lastOpenChild.parent == this);
/*     */       
/* 343 */       assert (child.prevOpen == null);
/* 344 */       assert (child.nextOpen == null);
/* 345 */       child.prevOpen = this.lastOpenChild;
/* 346 */       assert (this.lastOpenChild.nextOpen == null);
/* 347 */       this.lastOpenChild.nextOpen = child;
/*     */     }
/*     */     
/* 350 */     this.lastOpenChild = child;
/*     */     
/* 352 */     return (TypedXmlWriter)child.createFacade();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\ContainerElement.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */