/*    */ package com.sun.xml.bind.v2.model.annotation;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.core.ErrorHandler;
/*    */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*    */ import java.lang.annotation.Annotation;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class AbstractInlineAnnotationReaderImpl<T, C, F, M>
/*    */   implements AnnotationReader<T, C, F, M>
/*    */ {
/*    */   private ErrorHandler errorHandler;
/*    */   
/*    */   public void setErrorHandler(ErrorHandler errorHandler)
/*    */   {
/* 22 */     if (errorHandler == null)
/* 23 */       throw new IllegalArgumentException();
/* 24 */     this.errorHandler = errorHandler;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public final ErrorHandler getErrorHandler()
/*    */   {
/* 31 */     assert (this.errorHandler != null) : "error handler must be set before use";
/* 32 */     return this.errorHandler;
/*    */   }
/*    */   
/*    */   public final <A extends Annotation> A getMethodAnnotation(Class<A> annotation, M getter, M setter, Locatable srcPos) {
/* 36 */     A a1 = getter == null ? null : getMethodAnnotation(annotation, getter, srcPos);
/* 37 */     A a2 = setter == null ? null : getMethodAnnotation(annotation, setter, srcPos);
/*    */     
/* 39 */     if (a1 == null) {
/* 40 */       if (a2 == null) {
/* 41 */         return null;
/*    */       }
/* 43 */       return a2;
/*    */     }
/* 45 */     if (a2 == null) {
/* 46 */       return a1;
/*    */     }
/*    */     
/* 49 */     getErrorHandler().error(new IllegalAnnotationException(Messages.DUPLICATE_ANNOTATIONS.format(new Object[] { annotation.getName(), fullName(getter), fullName(setter) }), a1, a2));
/*    */     
/*    */ 
/*    */ 
/*    */ 
/* 54 */     return a1;
/*    */   }
/*    */   
/*    */ 
/*    */   public boolean hasMethodAnnotation(Class<? extends Annotation> annotation, String propertyName, M getter, M setter, Locatable srcPos)
/*    */   {
/* 60 */     boolean x = (getter != null) && (hasMethodAnnotation(annotation, getter));
/* 61 */     boolean y = (setter != null) && (hasMethodAnnotation(annotation, setter));
/*    */     
/* 63 */     if ((x) && (y))
/*    */     {
/* 65 */       getMethodAnnotation(annotation, getter, setter, srcPos);
/*    */     }
/*    */     
/* 68 */     return (x) || (y);
/*    */   }
/*    */   
/*    */   protected abstract String fullName(M paramM);
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\annotation\AbstractInlineAnnotationReaderImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */