/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerCharacter<BeanT>
/*    */   extends Lister<BeanT, char[], Character, CharacterArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Character.TYPE, new PrimitiveArrayListerCharacter());
/*    */   }
/*    */   
/*    */   public ListIterator<Character> iterator(final char[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Character next()
/*    */       {
/* 30 */         return Character.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public CharacterArrayPack startPacking(BeanT current, Accessor<BeanT, char[]> acc) {
/* 36 */     return new CharacterArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(CharacterArrayPack objects, Character o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(CharacterArrayPack pack, BeanT bean, Accessor<BeanT, char[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, char[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new char[0]);
/*    */   }
/*    */   
/*    */   static final class CharacterArrayPack {
/* 52 */     char[] buf = new char[16];
/*    */     int size;
/*    */     
/*    */     void add(Character b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         char[] nb = new char[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.charValue();
/*    */     }
/*    */     
/*    */     char[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       char[] r = new char[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerCharacter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */