/*    */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*    */ 
/*    */ import javax.xml.bind.ValidationEventLocator;
/*    */ import javax.xml.bind.helpers.ValidationEventLocatorImpl;
/*    */ import javax.xml.namespace.NamespaceContext;
/*    */ import javax.xml.stream.Location;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ abstract class StAXConnector
/*    */ {
/*    */   protected final XmlVisitor visitor;
/*    */   protected final UnmarshallingContext context;
/*    */   protected final XmlVisitor.TextPredictor predictor;
/*    */   public abstract void bridge()
/*    */     throws XMLStreamException;
/*    */   
/*    */   private final class TagNameImpl
/*    */     extends TagName
/*    */   {
/*    */     private TagNameImpl() {}
/*    */     
/*    */     public String getQname()
/*    */     {
/* 26 */       return StAXConnector.this.getCurrentQName();
/*    */     }
/*    */   }
/*    */   
/* 30 */   protected final TagName tagName = new TagNameImpl(null);
/*    */   
/*    */   protected StAXConnector(XmlVisitor visitor) {
/* 33 */     this.visitor = visitor;
/* 34 */     this.context = visitor.getContext();
/* 35 */     this.predictor = visitor.getPredictor();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   protected abstract Location getCurrentLocation();
/*    */   
/*    */ 
/*    */ 
/*    */   protected abstract String getCurrentQName();
/*    */   
/*    */ 
/*    */   protected final void handleStartDocument(NamespaceContext nsc)
/*    */     throws SAXException
/*    */   {
/* 50 */     this.visitor.startDocument(new LocatorEx() {
/*    */       public ValidationEventLocator getLocation() {
/* 52 */         return new ValidationEventLocatorImpl(this);
/*    */       }
/*    */       
/* 55 */       public int getColumnNumber() { return StAXConnector.this.getCurrentLocation().getColumnNumber(); }
/*    */       
/*    */       public int getLineNumber() {
/* 58 */         return StAXConnector.this.getCurrentLocation().getLineNumber();
/*    */       }
/*    */       
/* 61 */       public String getPublicId() { return StAXConnector.this.getCurrentLocation().getPublicId(); }
/*    */       
/*    */ 
/* 64 */       public String getSystemId() { return StAXConnector.this.getCurrentLocation().getSystemId(); } }, nsc);
/*    */   }
/*    */   
/*    */   protected final void handleEndDocument()
/*    */     throws SAXException
/*    */   {
/* 70 */     this.visitor.endDocument();
/*    */   }
/*    */   
/*    */   protected static String fixNull(String s) {
/* 74 */     if (s == null) return "";
/* 75 */     return s;
/*    */   }
/*    */   
/*    */   protected final String getQName(String prefix, String localName) {
/* 79 */     if ((prefix == null) || (prefix.length() == 0)) {
/* 80 */       return localName;
/*    */     }
/* 82 */     return prefix + ':' + localName;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\StAXConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */