/*     */ package com.sun.xml.bind.v2.util;
/*     */ 
/*     */ import java.util.AbstractList;
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class CollisionCheckStack<E>
/*     */   extends AbstractList<E>
/*     */ {
/*     */   private Object[] data;
/*     */   private int[] next;
/*  29 */   private int size = 0;
/*     */   
/*     */   private final int[] initialHash;
/*     */   
/*     */ 
/*     */   public CollisionCheckStack()
/*     */   {
/*  36 */     this.initialHash = new int[17];
/*  37 */     this.data = new Object[16];
/*  38 */     this.next = new int[16];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean push(E o)
/*     */   {
/*  48 */     if (this.data.length == this.size) {
/*  49 */       expandCapacity();
/*     */     }
/*  51 */     this.data[this.size] = o;
/*  52 */     int hash = hash(o);
/*  53 */     boolean r = findDuplicate(o, hash);
/*  54 */     this.next[this.size] = this.initialHash[hash];
/*  55 */     this.initialHash[hash] = (this.size + 1);
/*  56 */     this.size += 1;
/*  57 */     return r;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void pushNocheck(E o)
/*     */   {
/*  65 */     if (this.data.length == this.size)
/*  66 */       expandCapacity();
/*  67 */     this.data[this.size] = o;
/*  68 */     this.next[this.size] = -1;
/*  69 */     this.size += 1;
/*     */   }
/*     */   
/*     */   public E get(int index)
/*     */   {
/*  74 */     return (E)this.data[index];
/*     */   }
/*     */   
/*     */   public int size()
/*     */   {
/*  79 */     return this.size;
/*     */   }
/*     */   
/*     */   private int hash(Object o) {
/*  83 */     return System.identityHashCode(o) % this.initialHash.length;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public E pop()
/*     */   {
/*  90 */     this.size -= 1;
/*  91 */     Object o = this.data[this.size];
/*  92 */     this.data[this.size] = null;
/*  93 */     int n = this.next[this.size];
/*  94 */     if (n >= 0)
/*     */     {
/*     */ 
/*  97 */       int hash = hash(o);
/*  98 */       assert (this.initialHash[hash] == this.size + 1);
/*  99 */       this.initialHash[hash] = n;
/*     */     }
/* 101 */     return (E)o;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public E peek()
/*     */   {
/* 108 */     return (E)this.data[(this.size - 1)];
/*     */   }
/*     */   
/*     */   private boolean findDuplicate(E o, int hash) {
/* 112 */     int p = this.initialHash[hash];
/* 113 */     while (p != 0) {
/* 114 */       p--;
/* 115 */       Object existing = this.data[p];
/* 116 */       if (existing == o) return true;
/* 117 */       p = this.next[p];
/*     */     }
/* 119 */     return false;
/*     */   }
/*     */   
/*     */   private void expandCapacity() {
/* 123 */     int oldSize = this.data.length;
/* 124 */     int newSize = oldSize * 2;
/* 125 */     Object[] d = new Object[newSize];
/* 126 */     int[] n = new int[newSize];
/*     */     
/* 128 */     System.arraycopy(this.data, 0, d, 0, oldSize);
/* 129 */     System.arraycopy(this.next, 0, n, 0, oldSize);
/*     */     
/* 131 */     this.data = d;
/* 132 */     this.next = n;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void reset()
/*     */   {
/* 139 */     if (this.size > 0) {
/* 140 */       this.size = 0;
/* 141 */       Arrays.fill(this.initialHash, 0);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\util\CollisionCheckStack.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */