/*    */ package com.sun.xml.txw2.output;
/*    */ 
/*    */ import com.sun.xml.txw2.TxwException;
/*    */ import javax.xml.parsers.DocumentBuilder;
/*    */ import javax.xml.parsers.DocumentBuilderFactory;
/*    */ import javax.xml.parsers.ParserConfigurationException;
/*    */ import javax.xml.transform.dom.DOMResult;
/*    */ import org.w3c.dom.Document;
/*    */ import org.w3c.dom.Node;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class DomSerializer
/*    */   implements XmlSerializer
/*    */ {
/*    */   private final SaxSerializer serializer;
/*    */   
/*    */   public DomSerializer(Node node)
/*    */   {
/* 33 */     Dom2SaxAdapter adapter = new Dom2SaxAdapter(node);
/* 34 */     this.serializer = new SaxSerializer(adapter, adapter);
/*    */   }
/*    */   
/*    */   public DomSerializer(DOMResult domResult) {
/* 38 */     Node node = domResult.getNode();
/*    */     
/* 40 */     if (node == null) {
/*    */       try {
/* 42 */         DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
/* 43 */         dbf.setNamespaceAware(true);
/* 44 */         DocumentBuilder db = dbf.newDocumentBuilder();
/* 45 */         Document doc = db.newDocument();
/* 46 */         domResult.setNode(doc);
/* 47 */         this.serializer = new SaxSerializer(new Dom2SaxAdapter(doc));
/*    */       } catch (ParserConfigurationException pce) {
/* 49 */         throw new TxwException(pce);
/*    */       }
/*    */     } else {
/* 52 */       this.serializer = new SaxSerializer(new Dom2SaxAdapter(node));
/*    */     }
/*    */   }
/*    */   
/*    */   public void startDocument()
/*    */   {
/* 58 */     this.serializer.startDocument();
/*    */   }
/*    */   
/*    */   public void beginStartTag(String uri, String localName, String prefix) {
/* 62 */     this.serializer.beginStartTag(uri, localName, prefix);
/*    */   }
/*    */   
/*    */   public void writeAttribute(String uri, String localName, String prefix, StringBuilder value) {
/* 66 */     this.serializer.writeAttribute(uri, localName, prefix, value);
/*    */   }
/*    */   
/*    */   public void writeXmlns(String prefix, String uri) {
/* 70 */     this.serializer.writeXmlns(prefix, uri);
/*    */   }
/*    */   
/*    */   public void endStartTag(String uri, String localName, String prefix) {
/* 74 */     this.serializer.endStartTag(uri, localName, prefix);
/*    */   }
/*    */   
/*    */   public void endTag() {
/* 78 */     this.serializer.endTag();
/*    */   }
/*    */   
/*    */   public void text(StringBuilder text) {
/* 82 */     this.serializer.text(text);
/*    */   }
/*    */   
/*    */   public void cdata(StringBuilder text) {
/* 86 */     this.serializer.cdata(text);
/*    */   }
/*    */   
/*    */   public void comment(StringBuilder comment) {
/* 90 */     this.serializer.comment(comment);
/*    */   }
/*    */   
/*    */   public void endDocument() {
/* 94 */     this.serializer.endDocument();
/*    */   }
/*    */   
/*    */   public void flush() {}
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\output\DomSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */