package javax.wsdl;

import java.io.PrintWriter;
import java.io.StringWriter;

public class WSDLException
  extends Exception
{
  public static final long serialVersionUID = 1L;
  public static final String INVALID_WSDL = "INVALID_WSDL";
  public static final String PARSER_ERROR = "PARSER_ERROR";
  public static final String OTHER_ERROR = "OTHER_ERROR";
  public static final String CONFIGURATION_ERROR = "CONFIGURATION_ERROR";
  public static final String UNBOUND_PREFIX = "UNBOUND_PREFIX";
  public static final String NO_PREFIX_SPECIFIED = "NO_PREFIX_SPECIFIED";
  private String faultCode = null;
  private Throwable targetThrowable = null;
  private String location = null;
  
  public WSDLException(String paramString1, String paramString2, Throwable paramThrowable)
  {
    super(paramString2);
    setFaultCode(paramString1);
    setTargetException(paramThrowable);
  }
  
  public WSDLException(String paramString1, String paramString2)
  {
    this(paramString1, paramString2, null);
  }
  
  public void setFaultCode(String paramString)
  {
    this.faultCode = paramString;
  }
  
  public String getFaultCode()
  {
    return this.faultCode;
  }
  
  public void setTargetException(Throwable paramThrowable)
  {
    this.targetThrowable = paramThrowable;
  }
  
  public Throwable getTargetException()
  {
    return this.targetThrowable;
  }
  
  public void setLocation(String paramString)
  {
    this.location = paramString;
  }
  
  public String getLocation()
  {
    return this.location;
  }
  
  public String getMessage()
  {
    StringBuffer localStringBuffer = new StringBuffer();
    localStringBuffer.append("WSDLException");
    if (this.location != null) {
      try
      {
        localStringBuffer.append(" (at " + this.location + ")");
      }
      catch (IllegalArgumentException localIllegalArgumentException) {}
    }
    if (this.faultCode != null) {
      localStringBuffer.append(": faultCode=" + this.faultCode);
    }
    String str = super.getMessage();
    Object localObject = this.targetThrowable != null ? this.targetThrowable.getMessage() : null;
    if ((str != null) && ((localObject == null) || (!str.equals(localObject)))) {
      localStringBuffer.append(": " + str);
    }
    if (localObject != null) {
      localStringBuffer.append(": " + (String)localObject);
    }
    return localStringBuffer.toString();
  }
  
  public String toString()
  {
    StringWriter localStringWriter = new StringWriter();
    PrintWriter localPrintWriter = new PrintWriter(localStringWriter);
    localPrintWriter.print(getMessage() + ": ");
    if (this.targetThrowable != null) {
      this.targetThrowable.printStackTrace(localPrintWriter);
    }
    return localStringWriter.toString();
  }
}


/* Location:              /Users/anandkum/Downloads/axis-wsdl4j-1.5.1.jar!/javax/wsdl/WSDLException.class
 * Java compiler version: 2 (46.0)
 * JD-Core Version:       0.7.1
 */