package net.rubyeye.xmemcached;

import java.net.InetSocketAddress;
import java.util.Collection;
import java.util.concurrent.CountDownLatch;
import net.rubyeye.xmemcached.buffer.BufferAllocator;
import net.rubyeye.xmemcached.command.Command;
import net.rubyeye.xmemcached.command.CommandType;
import net.rubyeye.xmemcached.transcoders.Transcoder;
import net.rubyeye.xmemcached.utils.Protocol;

public abstract interface CommandFactory
{
  public abstract void setBufferAllocator(BufferAllocator paramBufferAllocator);
  
  public abstract Command createDeleteCommand(String paramString, byte[] paramArrayOfByte, int paramInt, boolean paramBoolean);
  
  public abstract Command createVersionCommand(CountDownLatch paramCountDownLatch, InetSocketAddress paramInetSocketAddress);
  
  public abstract Command createFlushAllCommand(CountDownLatch paramCountDownLatch, int paramInt, boolean paramBoolean);
  
  public abstract Command createStatsCommand(InetSocketAddress paramInetSocketAddress, CountDownLatch paramCountDownLatch, String paramString);
  
  public abstract Command createGetCommand(String paramString, byte[] paramArrayOfByte, CommandType paramCommandType, Transcoder paramTranscoder);
  
  public abstract <T> Command createGetMultiCommand(Collection<String> paramCollection, CountDownLatch paramCountDownLatch, CommandType paramCommandType, Transcoder<T> paramTranscoder);
  
  public abstract Command createIncrDecrCommand(String paramString, byte[] paramArrayOfByte, long paramLong1, long paramLong2, int paramInt, CommandType paramCommandType, boolean paramBoolean);
  
  public abstract Command createCASCommand(String paramString, byte[] paramArrayOfByte, int paramInt, Object paramObject, long paramLong, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createSetCommand(String paramString, byte[] paramArrayOfByte, int paramInt, Object paramObject, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createAddCommand(String paramString, byte[] paramArrayOfByte, int paramInt, Object paramObject, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createReplaceCommand(String paramString, byte[] paramArrayOfByte, int paramInt, Object paramObject, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createAppendCommand(String paramString, byte[] paramArrayOfByte, Object paramObject, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createPrependCommand(String paramString, byte[] paramArrayOfByte, Object paramObject, boolean paramBoolean, Transcoder paramTranscoder);
  
  public abstract Command createVerbosityCommand(CountDownLatch paramCountDownLatch, int paramInt, boolean paramBoolean);
  
  public abstract Command createAuthListMechanismsCommand(CountDownLatch paramCountDownLatch);
  
  public abstract Command createAuthStartCommand(String paramString, CountDownLatch paramCountDownLatch, byte[] paramArrayOfByte);
  
  public abstract Command createAuthStepCommand(String paramString, CountDownLatch paramCountDownLatch, byte[] paramArrayOfByte);
  
  public abstract Command createQuitCommand();
  
  public abstract Command createTouchCommand(String paramString, byte[] paramArrayOfByte, CountDownLatch paramCountDownLatch, int paramInt, boolean paramBoolean);
  
  public abstract Command createGetAndTouchCommand(String paramString, byte[] paramArrayOfByte, CountDownLatch paramCountDownLatch, int paramInt, boolean paramBoolean);
  
  public abstract Protocol getProtocol();
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\CommandFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */