/*     */ package net.rubyeye.xmemcached.command.binary;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BinaryIncrDecrCommand
/*     */   extends BaseBinaryCommand
/*     */ {
/*     */   private long amount;
/*     */   private long initial;
/*     */   
/*     */   public final long getAmount()
/*     */   {
/*  40 */     return this.amount;
/*     */   }
/*     */   
/*     */   public final void setAmount(long amount) {
/*  44 */     this.amount = amount;
/*     */   }
/*     */   
/*     */   public final long getInitial() {
/*  48 */     return this.initial;
/*     */   }
/*     */   
/*     */   public final void setInitial(long initial) {
/*  52 */     this.initial = initial;
/*     */   }
/*     */   
/*     */   public BinaryIncrDecrCommand(String key, byte[] keyBytes, long amount, long initial, int expTime, CommandType cmdType, boolean noreply)
/*     */   {
/*  57 */     super(key, keyBytes, cmdType, new CountDownLatch(1), 0, 0L, null, noreply, null);
/*     */     
/*  59 */     this.amount = amount;
/*  60 */     this.initial = initial;
/*  61 */     this.expTime = expTime;
/*  62 */     switch (cmdType) {
/*     */     case INCR: 
/*  64 */       this.opCode = (noreply ? OpCode.INCREMENT_QUIETLY : OpCode.INCREMENT);
/*  65 */       break;
/*     */     case DECR: 
/*  67 */       this.opCode = (noreply ? OpCode.DECREMENT_QUIETLY : OpCode.DECREMENT);
/*  68 */       break;
/*     */     default: 
/*  70 */       throw new IllegalArgumentException("Unknow cmd type for incr/decr:" + cmdType);
/*     */     }
/*     */     
/*     */   }
/*     */   
/*     */ 
/*     */   protected void fillExtras(CachedData data)
/*     */   {
/*  78 */     this.ioBuffer.putLong(this.amount);
/*  79 */     this.ioBuffer.putLong(this.initial);
/*  80 */     this.ioBuffer.putInt(this.expTime);
/*     */   }
/*     */   
/*     */   protected byte getExtrasLength()
/*     */   {
/*  85 */     return 20;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void fillValue(CachedData data) {}
/*     */   
/*     */ 
/*     */   protected int getValueLength(CachedData data)
/*     */   {
/*  95 */     return 0;
/*     */   }
/*     */   
/*     */ 
/*     */   protected boolean readValue(ByteBuffer buffer, int bodyLength, int keyLength, int extrasLength)
/*     */   {
/* 101 */     if (buffer.remaining() < 8) {
/* 102 */       return false;
/*     */     }
/* 104 */     long returnValue = buffer.getLong();
/* 105 */     setResult(Long.valueOf(returnValue));
/* 106 */     return true;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\binary\BinaryIncrDecrCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */