/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.List;
/*     */ import net.rubyeye.xmemcached.HashAlgorithm;
/*     */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ElectionMemcachedSessionLocator
/*     */   extends AbstractMemcachedSessionLocator
/*     */ {
/*     */   private volatile transient List<Session> sessions;
/*     */   private final HashAlgorithm hashAlgorithm;
/*     */   
/*     */   public ElectionMemcachedSessionLocator()
/*     */   {
/*  48 */     this.hashAlgorithm = HashAlgorithm.ELECTION_HASH;
/*     */   }
/*     */   
/*     */   public ElectionMemcachedSessionLocator(HashAlgorithm hashAlgorithm)
/*     */   {
/*  53 */     this.hashAlgorithm = hashAlgorithm;
/*     */   }
/*     */   
/*     */   public Session getSessionByKey(String key)
/*     */   {
/*  58 */     List<Session> copySessionList = new ArrayList(this.sessions);
/*  59 */     Session result = getSessionByElection(key, copySessionList);
/*     */     
/*  61 */     while ((!this.failureMode) && ((result == null) || (result.isClosed())) && (copySessionList.size() > 0)) {
/*  62 */       copySessionList.remove(result);
/*  63 */       result = getSessionByElection(key, copySessionList);
/*     */     }
/*  65 */     return result;
/*     */   }
/*     */   
/*     */   private Session getSessionByElection(String key, List<Session> copySessionList)
/*     */   {
/*  70 */     Session result = null;
/*  71 */     long highScore = 0L;
/*  72 */     for (Session session : copySessionList) {
/*  73 */       long hash = 0L;
/*  74 */       if ((session instanceof MemcachedTCPSession)) {
/*  75 */         MemcachedSession tcpSession = (MemcachedSession)session;
/*  76 */         for (int i = 0; i < tcpSession.getWeight(); i++) {
/*  77 */           hash = this.hashAlgorithm.hash(session.getRemoteSocketAddress().toString() + "-" + i + key);
/*     */           
/*     */ 
/*  80 */           if (hash > highScore) {
/*  81 */             highScore = hash;
/*  82 */             result = session;
/*     */           }
/*     */         }
/*     */       } else {
/*  86 */         hash = this.hashAlgorithm.hash(session.getRemoteSocketAddress().toString() + key);
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*  91 */       if (hash > highScore) {
/*  92 */         highScore = hash;
/*  93 */         result = session;
/*     */       }
/*     */     }
/*  96 */     return result;
/*     */   }
/*     */   
/*     */   public void updateSessions(Collection<Session> list) {
/* 100 */     this.sessions = new ArrayList(list);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\ElectionMemcachedSessionLocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */