/*    */ package org.codehaus.jackson.map.ser.impl;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.net.InetAddress;
/*    */ import org.codehaus.jackson.JsonGenerationException;
/*    */ import org.codehaus.jackson.JsonGenerator;
/*    */ import org.codehaus.jackson.map.SerializerProvider;
/*    */ import org.codehaus.jackson.map.TypeSerializer;
/*    */ import org.codehaus.jackson.map.ser.ScalarSerializerBase;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class InetAddressSerializer
/*    */   extends ScalarSerializerBase<InetAddress>
/*    */ {
/* 21 */   public static final InetAddressSerializer instance = new InetAddressSerializer();
/*    */   
/* 23 */   public InetAddressSerializer() { super(InetAddress.class); }
/*    */   
/*    */ 
/*    */ 
/*    */   public void serialize(InetAddress value, JsonGenerator jgen, SerializerProvider provider)
/*    */     throws IOException, JsonGenerationException
/*    */   {
/* 30 */     String str = value.toString().trim();
/* 31 */     int ix = str.indexOf('/');
/* 32 */     if (ix >= 0) {
/* 33 */       if (ix == 0) {
/* 34 */         str = str.substring(1);
/*    */       } else {
/* 36 */         str = str.substring(0, ix);
/*    */       }
/*    */     }
/* 39 */     jgen.writeString(str);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public void serializeWithType(InetAddress value, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)
/*    */     throws IOException, JsonGenerationException
/*    */   {
/* 48 */     typeSer.writeTypePrefixForScalar(value, jgen, InetAddress.class);
/* 49 */     serialize(value, jgen, provider);
/* 50 */     typeSer.writeTypeSuffixForScalar(value, jgen);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\ser\impl\InetAddressSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */