/*    */ package org.codehaus.janino;
/*    */ 
/*    */ import java.util.ArrayList;
/*    */ import java.util.List;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class MethodDescriptor
/*    */ {
/*    */   public final String[] parameterFDs;
/*    */   public final String returnFD;
/*    */   
/*    */   public MethodDescriptor(String[] parameterFDs, String returnFD)
/*    */   {
/* 44 */     this.parameterFDs = parameterFDs;
/* 45 */     this.returnFD = returnFD;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public MethodDescriptor(String s)
/*    */   {
/* 52 */     if (s.charAt(0) != '(') { throw new JaninoRuntimeException();
/*    */     }
/* 54 */     int from = 1;
/* 55 */     List parameterFDs = new ArrayList();
/* 56 */     while (s.charAt(from) != ')') {
/* 57 */       int to = from;
/* 58 */       while (s.charAt(to) == '[') to++;
/* 59 */       if ("BCDFIJSZ".indexOf(s.charAt(to)) != -1) {
/* 60 */         to++;
/*    */       }
/* 62 */       else if (s.charAt(to) == 'L') {
/* 63 */         for (to++; s.charAt(to) != ';'; to++) {}
/* 64 */         to++;
/*    */       } else {
/* 66 */         throw new JaninoRuntimeException();
/*    */       }
/* 68 */       parameterFDs.add(s.substring(from, to));
/* 69 */       from = to;
/*    */     }
/* 71 */     this.parameterFDs = ((String[])parameterFDs.toArray(new String[parameterFDs.size()]));
/* 72 */     this.returnFD = s.substring(++from);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public String toString()
/*    */   {
/* 79 */     StringBuffer sb = new StringBuffer("(");
/* 80 */     for (int i = 0; i < this.parameterFDs.length; i++) sb.append(this.parameterFDs[i]);
/* 81 */     return ')' + this.returnFD;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static String prependParameter(String md, String parameterFD)
/*    */   {
/* 88 */     return '(' + parameterFD + md.substring(1);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\MethodDescriptor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */