/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.reflect.AccessibleObject;
/*    */ import java.lang.reflect.AnnotatedElement;
/*    */ import java.lang.reflect.Field;
/*    */ import java.lang.reflect.Member;
/*    */ import java.lang.reflect.Method;
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Collection;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.XMember;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ 
/*    */ 
/*    */ public abstract class JavaXMember
/*    */   extends JavaXAnnotatedElement
/*    */   implements XMember
/*    */ {
/*    */   private final Type type;
/*    */   private final TypeEnvironment env;
/*    */   private final JavaXType xType;
/*    */   
/*    */   protected static Type typeOf(Member member, TypeEnvironment env)
/*    */   {
/* 25 */     if ((member instanceof Field)) {
/* 26 */       return env.bind(((Field)member).getGenericType());
/*    */     }
/* 28 */     if ((member instanceof Method)) {
/* 29 */       return env.bind(((Method)member).getGenericReturnType());
/*    */     }
/* 31 */     throw new IllegalArgumentException("Member " + member + " is neither a field nor a method");
/*    */   }
/*    */   
/*    */   protected JavaXMember(Member member, Type type, TypeEnvironment env, JavaReflectionManager factory, JavaXType xType) {
/* 35 */     super((AnnotatedElement)member, factory);
/* 36 */     this.type = type;
/* 37 */     this.env = env;
/* 38 */     this.xType = xType;
/*    */   }
/*    */   
/*    */   public XClass getType() {
/* 42 */     return this.xType.getType();
/*    */   }
/*    */   
/*    */   public abstract String getName();
/*    */   
/*    */   protected Type getJavaType() {
/* 48 */     return this.env.bind(this.type);
/*    */   }
/*    */   
/*    */   protected TypeEnvironment getTypeEnvironment() {
/* 52 */     return this.env;
/*    */   }
/*    */   
/*    */   protected Member getMember() {
/* 56 */     return (Member)toAnnotatedElement();
/*    */   }
/*    */   
/*    */   public Class<? extends Collection> getCollectionClass() {
/* 60 */     return this.xType.getCollectionClass();
/*    */   }
/*    */   
/*    */   public XClass getClassOrElementClass() {
/* 64 */     return this.xType.getClassOrElementClass();
/*    */   }
/*    */   
/*    */   public XClass getElementClass() {
/* 68 */     return this.xType.getElementClass();
/*    */   }
/*    */   
/*    */   public XClass getMapKey() {
/* 72 */     return this.xType.getMapKey();
/*    */   }
/*    */   
/*    */   public boolean isArray() {
/* 76 */     return this.xType.isArray();
/*    */   }
/*    */   
/*    */   public boolean isCollection() {
/* 80 */     return this.xType.isCollection();
/*    */   }
/*    */   
/*    */   public int getModifiers() {
/* 84 */     return getMember().getModifiers();
/*    */   }
/*    */   
/*    */   public final boolean isTypeResolved() {
/* 88 */     return this.xType.isResolved();
/*    */   }
/*    */   
/*    */   public void setAccessible(boolean accessible) {
/* 92 */     ((AccessibleObject)getMember()).setAccessible(accessible);
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXMember.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */