/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.reflect.Member;
/*    */ import java.lang.reflect.Method;
/*    */ import java.lang.reflect.Type;
/*    */ import org.hibernate.annotations.common.reflection.XMethod;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class JavaXMethod
/*    */   extends JavaXMember
/*    */   implements XMethod
/*    */ {
/*    */   static JavaXMethod create(Member member, TypeEnvironment context, JavaReflectionManager factory)
/*    */   {
/* 17 */     Type propType = typeOf(member, context);
/* 18 */     JavaXType xType = factory.toXType(context, propType);
/* 19 */     return new JavaXMethod(member, propType, context, factory, xType);
/*    */   }
/*    */   
/*    */   private JavaXMethod(Member member, Type type, TypeEnvironment env, JavaReflectionManager factory, JavaXType xType) {
/* 23 */     super(member, type, env, factory, xType);
/* 24 */     assert ((member instanceof Method));
/*    */   }
/*    */   
/*    */   public String getName() {
/* 28 */     return getMember().getName();
/*    */   }
/*    */   
/*    */   public Object invoke(Object target, Object... parameters) {
/*    */     try {
/* 33 */       return ((Method)getMember()).invoke(target, parameters);
/*    */     }
/*    */     catch (NullPointerException e) {
/* 36 */       throw new IllegalArgumentException("Invoking " + getName() + " on a  null object", e);
/*    */     }
/*    */     catch (IllegalArgumentException e) {
/* 39 */       throw new IllegalArgumentException("Invoking " + getName() + " with wrong parameters", e);
/*    */     }
/*    */     catch (Exception e) {
/* 42 */       throw new IllegalStateException("Unable to invoke " + getName(), e);
/*    */     }
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXMethod.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */