/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.beans.Introspector;
/*    */ import java.lang.reflect.Field;
/*    */ import java.lang.reflect.Member;
/*    */ import java.lang.reflect.Method;
/*    */ import java.lang.reflect.Type;
/*    */ import org.hibernate.annotations.common.reflection.XProperty;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ 
/*    */ 
/*    */ 
/*    */ class JavaXProperty
/*    */   extends JavaXMember
/*    */   implements XProperty
/*    */ {
/*    */   static JavaXProperty create(Member member, TypeEnvironment context, JavaReflectionManager factory)
/*    */   {
/* 19 */     Type propType = typeOf(member, context);
/* 20 */     JavaXType xType = factory.toXType(context, propType);
/* 21 */     return new JavaXProperty(member, propType, context, factory, xType);
/*    */   }
/*    */   
/*    */   private JavaXProperty(Member member, Type type, TypeEnvironment env, JavaReflectionManager factory, JavaXType xType) {
/* 25 */     super(member, type, env, factory, xType);
/* 26 */     assert (((member instanceof Field)) || ((member instanceof Method)));
/*    */   }
/*    */   
/*    */   public String getName() {
/* 30 */     String fullName = getMember().getName();
/* 31 */     if ((getMember() instanceof Method)) {
/* 32 */       if (fullName.startsWith("get")) {
/* 33 */         return Introspector.decapitalize(fullName.substring("get".length()));
/*    */       }
/* 35 */       if (fullName.startsWith("is")) {
/* 36 */         return Introspector.decapitalize(fullName.substring("is".length()));
/*    */       }
/* 38 */       throw new RuntimeException("Method " + fullName + " is not a property getter");
/*    */     }
/*    */     
/* 41 */     return fullName;
/*    */   }
/*    */   
/*    */   public Object invoke(Object target, Object... parameters)
/*    */   {
/* 46 */     if (parameters.length != 0) {
/* 47 */       throw new IllegalArgumentException("An XProperty cannot have invoke parameters");
/*    */     }
/*    */     try {
/* 50 */       if ((getMember() instanceof Method)) {
/* 51 */         return ((Method)getMember()).invoke(target, new Object[0]);
/*    */       }
/*    */       
/* 54 */       return ((Field)getMember()).get(target);
/*    */     }
/*    */     catch (NullPointerException e)
/*    */     {
/* 58 */       throw new IllegalArgumentException("Invoking " + getName() + " on a  null object", e);
/*    */     }
/*    */     catch (IllegalArgumentException e) {
/* 61 */       throw new IllegalArgumentException("Invoking " + getName() + " with wrong parameters", e);
/*    */     }
/*    */     catch (Exception e) {
/* 64 */       throw new IllegalStateException("Unable to invoke " + getName(), e);
/*    */     }
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 70 */     return getName();
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */