package prefuse.action.assignment;

import java.util.logging.Logger;
import prefuse.action.ItemAction;
import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.PredicateChain;
import prefuse.visual.VisualItem;

public class ShapeAction
  extends ItemAction
{
  protected PredicateChain m_chain = null;
  protected int m_defaultShape = 0;
  
  public ShapeAction() {}
  
  public ShapeAction(String paramString)
  {
    super(paramString);
  }
  
  public ShapeAction(String paramString, int paramInt)
  {
    super(paramString);
    setDefaultShape(paramInt);
  }
  
  public int getDefaultSize()
  {
    return this.m_defaultShape;
  }
  
  public void setDefaultShape(int paramInt)
  {
    this.m_defaultShape = paramInt;
  }
  
  public void add(Predicate paramPredicate, int paramInt)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, new Integer(paramInt));
  }
  
  public void add(String paramString, int paramInt)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramInt);
  }
  
  public void add(Predicate paramPredicate, ShapeAction paramShapeAction)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramShapeAction);
  }
  
  public void add(String paramString, ShapeAction paramShapeAction)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramShapeAction);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    paramVisualItem.setShape(getShape(paramVisualItem));
  }
  
  public int getShape(VisualItem paramVisualItem)
  {
    if (this.m_chain != null)
    {
      Object localObject = this.m_chain.get(paramVisualItem);
      if (localObject != null)
      {
        if ((localObject instanceof ShapeAction)) {
          return ((ShapeAction)localObject).getShape(paramVisualItem);
        }
        if ((localObject instanceof Number)) {
          return ((Number)localObject).intValue();
        }
        Logger.getLogger(getClass().getName()).warning("Unrecognized Object from predicate chain.");
      }
    }
    return this.m_defaultShape;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\assignment\ShapeAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */