package prefuse.action.assignment;

import java.util.logging.Logger;
import prefuse.action.ItemAction;
import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.PredicateChain;
import prefuse.visual.VisualItem;

public class SizeAction
  extends ItemAction
{
  protected PredicateChain m_chain = null;
  protected double m_defaultSize = 1.0D;
  
  public SizeAction() {}
  
  public SizeAction(String paramString)
  {
    super(paramString);
  }
  
  public SizeAction(String paramString, double paramDouble)
  {
    super(paramString);
    setDefaultSize(paramDouble);
  }
  
  public double getDefaultSize()
  {
    return this.m_defaultSize;
  }
  
  public void setDefaultSize(double paramDouble)
  {
    this.m_defaultSize = paramDouble;
  }
  
  public void add(Predicate paramPredicate, double paramDouble)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, new Double(paramDouble));
  }
  
  public void add(String paramString, double paramDouble)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramDouble);
  }
  
  public void add(Predicate paramPredicate, SizeAction paramSizeAction)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramSizeAction);
  }
  
  public void add(String paramString, SizeAction paramSizeAction)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramSizeAction);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    double d1 = getSize(paramVisualItem);
    double d2 = paramVisualItem.getSize();
    paramVisualItem.setStartSize(d2);
    paramVisualItem.setEndSize(d1);
    paramVisualItem.setSize(d1);
  }
  
  public double getSize(VisualItem paramVisualItem)
  {
    if (this.m_chain != null)
    {
      Object localObject = this.m_chain.get(paramVisualItem);
      if (localObject != null)
      {
        if ((localObject instanceof SizeAction)) {
          return ((SizeAction)localObject).getSize(paramVisualItem);
        }
        if ((localObject instanceof Number)) {
          return ((Number)localObject).doubleValue();
        }
        Logger.getLogger(getClass().getName()).warning("Unrecognized Object from predicate chain.");
      }
    }
    return this.m_defaultSize;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\assignment\SizeAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */