package prefuse.action.layout;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import prefuse.Visualization;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.VisualItem;

public class CircleLayout
  extends Layout
{
  private double m_radius;
  
  public CircleLayout(String paramString)
  {
    super(paramString);
  }
  
  public CircleLayout(String paramString, double paramDouble)
  {
    super(paramString);
    this.m_radius = paramDouble;
  }
  
  public double getRadius()
  {
    return this.m_radius;
  }
  
  public void setRadius(double paramDouble)
  {
    this.m_radius = paramDouble;
  }
  
  public void run(double paramDouble)
  {
    TupleSet localTupleSet = this.m_vis.getGroup(this.m_group);
    int i = localTupleSet.getTupleCount();
    Rectangle2D localRectangle2D = getLayoutBounds();
    double d1 = localRectangle2D.getHeight();
    double d2 = localRectangle2D.getWidth();
    double d3 = localRectangle2D.getCenterX();
    double d4 = localRectangle2D.getCenterY();
    double d5 = this.m_radius;
    if (d5 <= 0.0D) {
      d5 = 0.45D * (d1 < d2 ? d1 : d2);
    }
    Iterator localIterator = localTupleSet.tuples();
    for (int j = 0; localIterator.hasNext(); j++)
    {
      VisualItem localVisualItem = (VisualItem)localIterator.next();
      double d6 = 6.283185307179586D * j / i;
      double d7 = Math.cos(d6) * d5 + d3;
      double d8 = Math.sin(d6) * d5 + d4;
      setX(localVisualItem, null, d7);
      setY(localVisualItem, null, d8);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\layout\CircleLayout.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */