package prefuse.controls;

import java.awt.event.MouseEvent;
import java.util.Iterator;
import prefuse.Visualization;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class NeighborHighlightControl
  extends ControlAdapter
{
  private String activity = null;
  private boolean highlightWithInvisibleEdge = false;
  
  public NeighborHighlightControl()
  {
    this(null);
  }
  
  public NeighborHighlightControl(String paramString)
  {
    this.activity = paramString;
  }
  
  public void itemEntered(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if ((paramVisualItem instanceof NodeItem)) {
      setNeighborHighlight((NodeItem)paramVisualItem, true);
    }
  }
  
  public void itemExited(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if ((paramVisualItem instanceof NodeItem)) {
      setNeighborHighlight((NodeItem)paramVisualItem, false);
    }
  }
  
  protected void setNeighborHighlight(NodeItem paramNodeItem, boolean paramBoolean)
  {
    Iterator localIterator = paramNodeItem.edges();
    while (localIterator.hasNext())
    {
      EdgeItem localEdgeItem = (EdgeItem)localIterator.next();
      NodeItem localNodeItem = localEdgeItem.getAdjacentItem(paramNodeItem);
      if ((localEdgeItem.isVisible()) || (this.highlightWithInvisibleEdge))
      {
        localEdgeItem.setHighlighted(paramBoolean);
        localNodeItem.setHighlighted(paramBoolean);
      }
    }
    if (this.activity != null) {
      paramNodeItem.getVisualization().run(this.activity);
    }
  }
  
  public boolean isHighlightWithInvisibleEdge()
  {
    return this.highlightWithInvisibleEdge;
  }
  
  public void setHighlightWithInvisibleEdge(boolean paramBoolean)
  {
    this.highlightWithInvisibleEdge = paramBoolean;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\NeighborHighlightControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */