package prefuse.controls;

import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.util.GraphicsLib;
import prefuse.util.display.DisplayLib;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class ZoomToFitControl
  extends ControlAdapter
{
  private long m_duration = 2000L;
  private int m_margin = 50;
  private int m_button = 4;
  private boolean m_zoomOverItem = true;
  private String m_group = Visualization.ALL_ITEMS;
  
  public ZoomToFitControl() {}
  
  public ZoomToFitControl(String paramString)
  {
    this.m_group = paramString;
  }
  
  public ZoomToFitControl(int paramInt)
  {
    this.m_button = paramInt;
  }
  
  public ZoomToFitControl(String paramString, int paramInt)
  {
    this.m_group = paramString;
    this.m_button = paramInt;
  }
  
  public ZoomToFitControl(String paramString, int paramInt1, long paramLong, int paramInt2)
  {
    this.m_group = paramString;
    this.m_margin = paramInt1;
    this.m_duration = paramLong;
    this.m_button = paramInt2;
  }
  
  public void itemClicked(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_zoomOverItem) {
      mouseClicked(paramMouseEvent);
    }
  }
  
  public void mouseClicked(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      Display localDisplay = (Display)paramMouseEvent.getComponent();
      Visualization localVisualization = localDisplay.getVisualization();
      Rectangle2D localRectangle2D = localVisualization.getBounds(this.m_group);
      GraphicsLib.expand(localRectangle2D, this.m_margin / localDisplay.getScale());
      DisplayLib.fitViewToBounds(localDisplay, localRectangle2D, this.m_duration);
    }
  }
  
  public boolean isZoomOverItem()
  {
    return this.m_zoomOverItem;
  }
  
  public void setZoomOverItem(boolean paramBoolean)
  {
    this.m_zoomOverItem = paramBoolean;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\ZoomToFitControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */