package prefuse.data.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import prefuse.data.Graph;
import prefuse.util.io.IOLib;

public abstract class AbstractGraphReader
  implements GraphReader
{
  public Graph readGraph(String paramString)
    throws DataIOException
  {
    try
    {
      InputStream localInputStream = IOLib.streamFromString(paramString);
      if (localInputStream == null) {
        throw new DataIOException("Couldn't find " + paramString + ". Not a valid file, URL, or resource locator.");
      }
      return readGraph(localInputStream);
    }
    catch (IOException localIOException)
    {
      throw new DataIOException(localIOException);
    }
  }
  
  public Graph readGraph(URL paramURL)
    throws DataIOException
  {
    try
    {
      return readGraph(paramURL.openStream());
    }
    catch (IOException localIOException)
    {
      throw new DataIOException(localIOException);
    }
  }
  
  public Graph readGraph(File paramFile)
    throws DataIOException
  {
    try
    {
      return readGraph(new FileInputStream(paramFile));
    }
    catch (FileNotFoundException localFileNotFoundException)
    {
      throw new DataIOException(localFileNotFoundException);
    }
  }
  
  public abstract Graph readGraph(InputStream paramInputStream)
    throws DataIOException;
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\AbstractGraphReader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */