package prefuse.data.query;

import javax.swing.JComponent;
import prefuse.data.Table;
import prefuse.data.Tuple;
import prefuse.data.event.TupleSetListener;
import prefuse.data.expression.AbstractPredicate;
import prefuse.data.search.PrefixSearchTupleSet;
import prefuse.data.search.SearchTupleSet;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ui.JSearchPanel;
import prefuse.visual.VisualTable;

public class SearchQueryBinding
  extends DynamicQueryBinding
{
  private SearchTupleSet m_set;
  private Listener m_lstnr = new Listener(null);
  private Object m_lock;
  
  public SearchQueryBinding(Table paramTable, String paramString)
  {
    this(paramTable, paramString, new PrefixSearchTupleSet());
  }
  
  public SearchQueryBinding(Table paramTable, String paramString, SearchTupleSet paramSearchTupleSet)
  {
    super(paramTable, paramString);
    setPredicate(new SearchBindingPredicate(null));
    this.m_set = paramSearchTupleSet;
    this.m_set.index(paramTable.tuples(), paramString);
    this.m_set.addTupleSetListener(this.m_lstnr);
    if ((paramTable instanceof VisualTable)) {
      this.m_lock = ((VisualTable)paramTable).getVisualization();
    }
  }
  
  public SearchTupleSet getSearchSet()
  {
    return this.m_set;
  }
  
  public JComponent createComponent()
  {
    return createSearchPanel();
  }
  
  public JSearchPanel createSearchPanel()
  {
    return createSearchPanel(this.m_set instanceof PrefixSearchTupleSet);
  }
  
  public JSearchPanel createSearchPanel(boolean paramBoolean)
  {
    JSearchPanel localJSearchPanel = new JSearchPanel(this.m_set, this.m_field, paramBoolean);
    if (this.m_lock != null) {
      localJSearchPanel.setLock(this.m_lock);
    }
    return localJSearchPanel;
  }
  
  private class Listener
    implements TupleSetListener
  {
    private Listener() {}
    
    public void tupleSetChanged(TupleSet paramTupleSet, Tuple[] paramArrayOfTuple1, Tuple[] paramArrayOfTuple2)
    {
      ((SearchQueryBinding.SearchBindingPredicate)SearchQueryBinding.this.getPredicate()).touch();
    }
  }
  
  private class SearchBindingPredicate
    extends AbstractPredicate
  {
    private SearchBindingPredicate() {}
    
    public boolean getBoolean(Tuple paramTuple)
    {
      String str = SearchQueryBinding.this.m_set.getQuery();
      return (str == null) || (str.length() == 0) || (SearchQueryBinding.this.m_set.containsTuple(paramTuple));
    }
    
    public void touch()
    {
      fireExpressionChange();
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\query\SearchQueryBinding.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */