package prefuse.util;

import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import prefuse.data.Tuple;
import prefuse.data.event.ExpressionListener;
import prefuse.data.event.TupleSetListener;
import prefuse.data.expression.Expression;
import prefuse.data.tuple.TupleSet;

public abstract class UpdateListener
  implements ExpressionListener, TupleSetListener, ComponentListener
{
  protected abstract void update(Object paramObject);
  
  public void expressionChanged(Expression paramExpression)
  {
    update(paramExpression);
  }
  
  public void tupleSetChanged(TupleSet paramTupleSet, Tuple[] paramArrayOfTuple1, Tuple[] paramArrayOfTuple2)
  {
    update(paramTupleSet);
  }
  
  public void componentResized(ComponentEvent paramComponentEvent)
  {
    update(paramComponentEvent.getSource());
  }
  
  public void componentHidden(ComponentEvent paramComponentEvent) {}
  
  public void componentMoved(ComponentEvent paramComponentEvent) {}
  
  public void componentShown(ComponentEvent paramComponentEvent) {}
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\UpdateListener.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */