package prefuse.util.ui;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.JComponent;

public class JFastLabel
  extends JComponent
{
  private String m_text;
  private int m_valign = 1;
  private int m_halign = 2;
  private int m_fheight = -1;
  
  public JFastLabel()
  {
    this(null);
  }
  
  public JFastLabel(String paramString)
  {
    this.m_text = paramString;
    setFont(getFont());
  }
  
  public String getText()
  {
    return this.m_text;
  }
  
  public void setText(String paramString)
  {
    this.m_text = paramString;
    repaint();
  }
  
  public void setFont(Font paramFont)
  {
    super.setFont(paramFont);
    this.m_fheight = -1;
  }
  
  public void setVerticalAlignment(int paramInt)
  {
    this.m_valign = paramInt;
    this.m_fheight = -1;
  }
  
  public void setHorizontalAlignment(int paramInt)
  {
    this.m_halign = paramInt;
  }
  
  public void paintComponent(Graphics paramGraphics)
  {
    Insets localInsets = getInsets();
    int i = getWidth() - localInsets.left - localInsets.right;
    int j = getHeight() - localInsets.top - localInsets.bottom;
    FontMetrics localFontMetrics;
    if (this.m_fheight == -1)
    {
      localFontMetrics = paramGraphics.getFontMetrics(getFont());
      if (this.m_valign == 3) {
        this.m_fheight = localFontMetrics.getDescent();
      } else if (this.m_valign == 1) {
        this.m_fheight = localFontMetrics.getAscent();
      }
    }
    paramGraphics.setColor(getBackground());
    paramGraphics.fillRect(localInsets.left, localInsets.top, i, j);
    if (this.m_text == null) {
      return;
    }
    paramGraphics.setFont(getFont());
    paramGraphics.setColor(getForeground());
    if (this.m_valign == 3) {
      j = j - this.m_fheight - localInsets.bottom;
    } else {
      j = localInsets.top + this.m_fheight;
    }
    switch (this.m_halign)
    {
    case 4: 
      localFontMetrics = paramGraphics.getFontMetrics(getFont());
      i = i - localInsets.right - localFontMetrics.stringWidth(this.m_text);
      break;
    case 0: 
      localFontMetrics = paramGraphics.getFontMetrics(getFont());
      i = localInsets.left + i / 2 - localFontMetrics.stringWidth(this.m_text) / 2;
      break;
    default: 
      i = localInsets.left;
    }
    paramGraphics.drawString(this.m_text, i, j);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ui\JFastLabel.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */